/**************************************************************************************************

Copyright (c) 2007   Tsunehiko Kato  and  4D2U Project, National Astronomical Observatory of Japan

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEFAvj̕擾
邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ܂Bɂ́A\tgEFA̕
gpAʁAύXAAfځAЕzATuCZXA/܂͔̔錠Aу\tgEFA
񋟂鑊ɓƂ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕɋLڂ̂Ƃ
B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂Ȃ񋟂܂B
łۏ؂Ƃ́AiA̖ړIւ̓KAьNQɂĂ̕ۏ؂܂݂܂AɌ
̂ł͂܂B ҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\t
gEFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
***************************************************************************************************/
#ifndef __MTK_COMMAND_H__
#define __MTK_COMMAND_H__
#include  "../common/math/vector3.h"



void	OnCommandDraw();
void	OnUpdateViewCtrl();
void	OnUpdateViewCtrl2();



//---------------
//  Stereo Mode
//---------------
void	OnStereo(char ty);


//----------
//  TARGET
//----------
void	OnTargetMoveControler();
void	OnTarget(char tgt);
void	OnTarget2(int tgt_no);
void	OnChangeTargetPos(const vector3f& pos);


//--------
//  VIEW
//--------


//-- DispSwitch
void	OnDispSwitch(char idx, char sw);
void	OnDispSwitchSetBit(char idx, char mask, bool bFlg);
void	OnDispSwitchToggle(char idx, char mask);

//-- Planet
void	OnEclipse(char sw);
void	OnPlanetAtmosphere(char val);
void	OnZoomMode(char val);
void	OnSetZoom(double val);
void	OnTopoZoomMode(char val);
void	OnSurfacePointer(bool bFlg);
void	OnLandingMode(char val);	
void	OnOortCloud(bool bFlg);

//-- Star
void	OnStar(char sw);
void	OnStarSet(char mask, bool bFlg);
void	OnStarMark(char idx);
void	OnSetLRef(float val);
void	OnLRef(float dL);

//-- Constellation
void	OnConstellation(char sw);
void	OnCnstSet(char mask, bool bFlg);

//-- Extragalactic Object
void	OnGalaxy(char sw);
void	OnGalaxySet(char mask, bool bFlg);
void	OnMarkVirgoCluster(bool bFlg);	

//-- Spacecraft Path
void	OnSpacecraftPath(char idx, bool bFlg);

//-- Milkyway
void	OnMilkyWay(char type_MilkyWay);

//-- Guide Line
void	OnCelestialGrid(bool bFlg);
void	OnEcliptic(bool bFlg);
void	OnGalacticGrid(bool bFlg);
void	OnHorizonCoord(bool bFlg);
void	OnDistScale(char sw);

//-- View
void	OnViewInfo(bool bFlg);
void	OnResetViewangle();

//-- TIME
void	OnDate(bool bFlg);
void	OnTimeStep(char type_timestep);
void	OnPresentTime();
void	OnRealTimeMode(bool bFlg);

//-- Scale
void	OnPresetScale(char ty);

//-- FontSize
void	OnFontSize(const char idx);

//-- Language
void	OnLang(char language);

//-- HELP
void	OnAbout();

//-- Full Screen Mode
void	OnFullScreen(bool bFlg);





//--------
//  Time
//--------
void	OnInitTime();
void	OnChangeTime(const double& JD);
void	OnTimeSetting();




//---------------
//  Planetarium
//---------------
void	OnPlanetariumAngle(float val);
void	OnResetView();


//-----------
//  Landing
//-----------
void	OnLanding();
void	OnLandingInit();
void	OnTakeoff();


//---------
//  Movie
//---------
void	OnMovieOpen(const char* filename);
void	OnMovieTitle(const char* menu_title, const char* dist_title);


//---------
//  Image
//---------
void	OnImageOpen(const char type, const char* filename);
void	OnImageTitle(const char* menu_title, const char* dist_title);

//---------
//  Audio
//---------
void	OnAudioTitle(const char* menu_title, const char* disp_title);



//---------
//  Popup
//---------
void	OnPopup(int popup_idx);


//-------------
//  Subtitles
//-------------
void	OnChangeSubtitlesIndex(int idx);


//---------
//  Other
//---------
void	OnSaveImage();
void	OnSaveImageHighRes();
void	OnSaveCubicImage();




#endif
