/**************************************************************************************************

Copyright (c) 2007   Tsunehiko Kato  and  4D2U Project, National Astronomical Observatory of Japan

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEFAvj̕擾
邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ܂Bɂ́A\tgEFA̕
gpAʁAύXAAfځAЕzATuCZXA/܂͔̔錠Aу\tgEFA
񋟂鑊ɓƂ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕɋLڂ̂Ƃ
B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂Ȃ񋟂܂B
łۏ؂Ƃ́AiA̖ړIւ̓KAьNQɂĂ̕ۏ؂܂݂܂AɌ
̂ł͂܂B ҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\t
gEFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
***************************************************************************************************/
#include  <windows.h>
#include  "mtk_gl_common.h"
#include  "mtk_eclipse.h"
#include  "mtk_triangle_mesh.h"
#include  <vector>
using namespace std;

vector3d
eclipse_get_shadow_center(const vector3d& r1, const double& R1, const vector3d& r2, const vector3d& rs)
{
	vector3d nv = normalize(r2 - rs);
	vector3d _r1 = r1 - r2;

	double b = -dot_product(nv, _r1);
	double c = norm2(_r1) - R1*R1;
	double D = b*b - c;

	if (D <= 0.0)  return vector3d(0,0,0);

	double t = -b - sqrt(D);


	return  t*nv + r2;
}

//********** *********
// r1, R1: e𗎂ƂV
// r2, R2: e𗎂ƂV
// rs, Rs: z
eclipse_info
calc_eclipse_info(const vector3d& r1, const double& R1, const vector3d& r2, const double& R2, const vector3d& rs, const double& Rs)
{
	eclipse_info  eci;
	eci.bFlg = false;

	// r2  r1 ̕zɋ߂ꍇ̓XLbv
	if (norm2(r1 - rs) <= norm2(r2 - rs))  return eci;

	// r2ʂ̕
	vector3d nv = normalize(r2 - rs);
	double L2s = norm(r2 - rs);

	// {eR[̎n_߂
	double L2umb = (R2 * L2s) / (Rs - R2);
	vector3d r_umb = L2umb * nv + r2;
	double sinth_umb = R2 / L2umb;
	double costh_umb = sqrt(1.0 - sinth_umb*sinth_umb);

	// eR[̎n_rh߂
	double LB = L2s / (1.0 + R2/Rs);
	double LA = L2s - LB;
	vector3d r_pen = LB * nv + rs;
	double sinth_pen = R2 / LA;
	double costh_pen = sqrt(1.0 - sinth_pen*sinth_pen);

	// r1 ƍł߂~R[̓_Ƃ̋ l ߂
	double L1h_sqr = norm2( r1 - r_pen );
	double a = dot_product(r1-r_pen, nv);
	double l = sqrt(L1h_sqr - a*a)*costh_pen - a*sinth_pen;
	if (l > R1)  return eci;	// R[̈̊O

	// z  nv ƂWn
	vector3d n1, n2;
	n1 = get_a_normal_unit_vector(nv);
	n2 = cross_product(nv, n1);
	eci.bFlg = true;
	eci.r_umb = r_umb;
	eci.r_pen = r_pen;
	eci.nv = nv;
	eci.n1 = n1;
	eci.n2 = n2;
	eci.sinth_umb = sinth_umb;
	eci.costh_umb = costh_umb;
	eci.sinth_pen = sinth_pen;
	eci.costh_pen = costh_pen;

	return  eci;
}

// zBĂ銄iSɉBĂƂɂPj
double
calc_eclipse_fraction(double R, double Dlt)
{
	if (R > 1.0) {
		// BV̂̎âقz̎a傫ꍇ
		if (Dlt < R - 1.0)	return  1.0;	// {e
		if (Dlt > R + 1.0)	return  0.0;	// ͈͊O
	} else {
		// BV̂̎âقz̎aꍇ
		if (Dlt > R + 1.0)	return 0.0;		// dȂȂ
		if (Dlt < 1.0 - R)	return R*R;		// ő̉
	}

	// IɉBiej̏ꍇiR > 1, R < 1 ŋʁj
	double a, b, th1, th2;
	a = (Dlt*Dlt + R*R - 1.0) / (2.0 * Dlt);
	b = (Dlt*Dlt - R*R + 1.0) / (2.0 * Dlt);
	th1 = atan2( sqrt(R*R - a*a), a );
	th2 = atan2( sqrt(1.0 - b*b), b );

	return (R*R*th1 - a* sqrt(R*R - a*a) + th2 - b * sqrt(1.0 - b*b)) / M_PI;
}


// n\ɗep̃|S
int
make_eclipse_shadow_polygon(const vector3d& r1, const double& R1, const vector3d& nz, const float f,
							const vector3d& r2, const double& R2,
							const vector3d& rs, const double& Rs,
							const int N1, const int N2, eclipse_vertex* vVtx)
{
	int vn = 0;
	clear_triangle_vtx();

	eclipse_info  eci;
	eci = calc_eclipse_info(r1, R1, r2, R2, rs, Rs);
	if (!eci.bFlg)  return 0;

	double tn_umb, tn_pen;
	vector3d r_umb, r_pen, nv, n1, n2, r1pen, _r1pen;

	tn_umb = eci.sinth_umb / eci.costh_umb; 
	tn_pen = eci.sinth_pen / eci.costh_pen;
	r_umb = eci.r_umb;
	r_pen = eci.r_pen;
	nv = eci.nv;
	n1 = eci.n1;
	n2 = eci.n2;
	r1pen = r_pen - r1;

	double alp = 1.0 / (1.0 - f);
	double az = (1.0 - alp);
	_r1pen = r1pen - az*dot_product(nz, r1pen) * nz;	// z ɏkeR[̎n_̈ʒu

	for (int i=0; i<N1; i++) {
		double tn;
		double u = float(i) / (N1-1);
		tn = tn_pen * (u*u);
		
		for (int j=0; j<N2; j++) {
			if (i==0 && j!=0)  break;

			double th_j = j*2.0*M_PI/N2 + 0.00001;
			double cs = cos(th_j);
			double sn = sin(th_j);
			double x, y;
			x = tn * cs;
			y = tn * sn;

			// R[̐ڐ̕xNg
			vector3d nt  = normalize( nv + x*n1 + y*n2 );
			vector3d _nt = nt - az*dot_product(nz, nt) * nz;

			// R[̐ڐƋƂ̌_߂
			double _a = norm2(_nt);
			double b = dot_product(_nt, _r1pen) / _a;
			double c = (norm2(_r1pen) - R1*R1) / _a;
			double D = b*b - c;
			if (D <= 0.0)  continue;
			double t = -b - sqrt(D);
			vector3d  pos = t*nt + r_pen;			// Wnł̈ʒu

			// a
			double thm, ths, R;
			thm = asin( R2 / norm(pos - r2) );
			ths = asin( Rs / norm(pos - rs) );
			R = thm/ths;

			// SԂ̋
			vector3d;
			double Dlt;
			vector3d nm = normalize( r2 - pos );
			vector3d ns = normalize( rs - pos );
			Dlt = acos( dot_product(nm, ns) ) / ths;

			// vZ
			double f = calc_eclipse_fraction(R, Dlt);
			if (f <= 0.0)  continue;
			vVtx[vn].pos = pos;
			vVtx[vn].f   = f;
			add_triangle_xy(x, y);

			vn++;
		}
	}

	// z  n1s ƂWn
	vector3d n1s, n1s1, n1s2;
	n1s  = normalize(rs - r1);
	n1s1 = get_a_normal_unit_vector(n1s);
	n1s2 = cross_product(n1s, n1s1);
	double L1s = norm(r1 - rs);
	double th_max = acos(R1 / L1s);

	const int N3 = 20;
	const int N4 = 3*N3;
	for (int i=0; i<N3; i++) {
		double u, th, rho, z;
		u = float(i) / (N3-1);
		th = th_max * u;
		rho = R1 * sin(th);
		z   = R1 * cos(th);

		for (int j=0; j<N4; j++) {
			if (i==0 && j!=0)  break;
			double th_j = j*2.0*M_PI/N4 + 0.00001;
			double cs = cos(th_j);
			double sn = sin(th_j);
			double x, y;
			x = rho * cs;
			y = rho * sn;
			vector3d  pos = x*n1s1 + y*n1s2 + z*n1s;

			// ]Ηɉďk
			pos = pos - f * dot_product(nz, pos) * nz;
			pos = pos + r1;

			// a
			double thm, ths, R;
			thm = asin( R2 / norm(pos - r2) );
			ths = asin( Rs / norm(pos - rs) );
			R = thm/ths;

			// SԂ̋
			vector3d;
			double Dlt;
			vector3d nm = normalize( r2 - pos );
			vector3d ns = normalize( rs - pos );
			Dlt = acos( dot_product(nm, ns) ) / ths;

			// vZ
			double frac = calc_eclipse_fraction(R, Dlt);
			if (frac <= 0.0)  continue;
			vVtx[vn].pos = pos;
			vVtx[vn].f   = frac;

			// R[Wɕϊ
			float _x, _y;
			vector3d _pos = pos - r_pen;
			_x = dot_product(_pos, n1) / dot_product(_pos, nv);
			_y = dot_product(_pos, n2) / dot_product(_pos, nv);
			add_triangle_xy(_x, _y);

			vn++;
		}
	}

	if (vn < 3) return 0;
	int nTri = triangulation();
	if (nTri <= 0)  return 0;

	return  nTri;
}



//--------------------------
//  fEq̉e`
//--------------------------
// r1, R1: e𗎂ƂV
// r2, R2: e𗎂ƂV
// rs, Rs: z
//--------------------------
void
draw_eclipse_shadow(const mtk_draw_struct& ds,
					const vector3d& r1, const double& R1,
					const vector3d& nz, const float f,		// e𗎂ƂV̂̎ƕΗ
					const vector3d& r2, const double& R2,
					const vector3d& rs, const double& Rs,
					const matrix3d& M,						// WnfWnւ̕ϊs
					const float th_c,						// eȗpx(rad)
					const int N1, const int N2,				//
					bool bShadow, bool bBorder)
{
	static eclipse_vertex vVtx[TRIANGLE_VTX_MAX];

	vector3d eF, eU, eR;
	quaterniond ori0 = ds.camera_base.get_ori() * get_base_camera_ori();
	quaternion_to_axes(ori0, eF, eU, eR);
	vector3d r_cam = get_local_camera_pos();
	const vector3d re = ds.camera.get_pos() + ( r_cam.x*eR + r_cam.y*eU - r_cam.z*eF)/ ds.camera.get_scale_factor();	// _̈ʒu

	const double   R = R1;					// fa
	const double   L = norm(re - r1);		// _ƘfS̋
	if (R >= L)			return;

	const double th_view = asin(R / L);
	if (th_view < th_c)  return;

	eclipse_info  eci;
	eci = calc_eclipse_info(r1, R1, r2, R2, rs, Rs);
	if (!eci.bFlg)  return;

	double costh_umb, sinth_umb, costh_pen, sinth_pen;
	vector3d r_umb, r_pen, nv, n1, n2;
	
	r_umb = eci.r_umb;
	r_pen = eci.r_pen;
	costh_umb = eci.costh_umb;
	sinth_umb = eci.sinth_umb;
	costh_pen = eci.costh_pen;
	sinth_pen = eci.sinth_pen;
	nv = eci.nv;
	n1 = eci.n1;
	n2 = eci.n2;
	vector3d _r1  = r1 - r2;

	glPushMatrix();
	glDisable(GL_LIGHTING);
	glRotatef(180, 0,0,1);

	//---  e̕\  ---
	if (bShadow) {
		int nTri = make_eclipse_shadow_polygon(r1, R1, nz, f, r2, R2, rs, Rs, N1, N2, vVtx);
		if (nTri > 0) {
			Triangle* vTri = get_triangle_list();
			glEnable(GL_BLEND);
			glDisable(GL_DEPTH_TEST);
			glBegin(GL_TRIANGLES);
			for (int i=0; i<nTri; i++) {
				const Triangle& tri = vTri[i];
				for (int j=0; j<3; j++) {
					int idx = tri.p[2-j];
					vector3d  pos2 = (vVtx[idx].pos - r1)/R1;	// e𗎂ƂV̂̒S_Ƃʒu
					vector3d  pos3 = M * pos2;
					double alp = vVtx[idx].f;
					glColor4f(0,0,0,alp);
					glVertex3dv( pos3.get_pointer() );
				}
			}
			glEnd();
			glEnable(GL_DEPTH_TEST);
		}
	}

	//---  E̕\  ---
	if (bBorder) {
		const double fac = 1.004;
		const int Nb_fac = (R1 > R2)  ?  1  :  int(R2/R1);

		vector3d r1umb, _r1umb;
		vector3d r1pen, _r1pen;
		r1umb = r_umb - r1;
		r1pen = r_pen - r1;
		double alp = 1.0 / (1.0 - f);
		double az = (alp - 1.0);
		_r1umb = r1umb + az*dot_product(nz, r1umb) * nz;	// z ɏk{eR[̎n_̈ʒu
		_r1pen = r1pen + az*dot_product(nz, r1pen) * nz;	// z ɏkeR[̎n_̈ʒu

		// {ë̋E
		bool bTotalEclipse = (-dot_product(r1umb, nv) < R1);
		const int Nb1 = 50 * Nb_fac;
		const double c0 = norm2(_r1umb) - R1*R1;
		double tn_umb = sinth_umb / costh_umb;
		glColor3f(1,0.5,0);
		glLineWidth(1.5);
	
		if (bTotalEclipse)	{ glBegin(GL_LINE_STRIP); }
		else				{ glBegin(GL_LINES); }
		for (int i=0; i<=Nb1; i++) {
			double cs = cos(i*2*3.14159/Nb1);
			double sn = sin(i*2*3.14159/Nb1);

			// R[̐ڐ̕xNg
			vector3d nt = normalize( -nv + tn_umb*cs*n1 + tn_umb*sn*n2 );

			// R[̐ڐƋƂ̌_߂
			vector3d _nt = nt + az*dot_product(nz, nt) * nz;
			double _a = norm2(_nt);
			double b = dot_product(_nt, _r1umb) / _a;
			double c = c0 / _a;
			double D = b*b - c;
			if (D <= 0.0)  continue;
			double t = -b + sqrt(D);

			vector3d  pos1 = t*nt + r_umb;				// Wnł̈ʒu
			vector3d  pos2 = fac * (pos1 - r1)/R1;		// e𗎂ƂV̂̒S_Ƃʒu
			vector3d  pos = M * pos2;

			glVertex3dv( pos.get_pointer() );
		}
		glEnd();


		// ë̋E
		const int Nb2 = 100 * Nb_fac;
		double tn_pen = sinth_pen / costh_pen;
		glColor3f(1,0.5,0);
		glLineWidth(1.5);
		glBegin(GL_LINE_STRIP);
		for (int i=0; i<=Nb2; i++) {
			double cs = cos(i*2*3.14159/Nb2);
			double sn = sin(i*2*3.14159/Nb2);

			// R[̐ڐ̕xNg
			vector3d nt = normalize( nv + tn_pen*cs*n1 + tn_pen*sn*n2 );

			// R[̐ڐƋƂ̌_߂
			vector3d _nt = nt + az*dot_product(nz, nt) * nz;
			double _a = norm2(_nt);
			double b = dot_product(_nt, _r1pen) / _a;
			double c = (norm2(_r1pen) - R1*R1) / _a;
			double D = b*b - c;
			if (D <= 0.0)  continue;
			double t = -b - sqrt(D);
			vector3d  pos1 = t*nt + r_pen;				// Wnł̈ʒu
			vector3d  pos2 = fac * (pos1 - r1)/R1;		// e𗎂ƂV̂̒S_Ƃʒu
			vector3d  pos = M * pos2;
			glVertex3dv( pos.get_pointer() );
		}
		glEnd();


		// S_
		{
			// R[̐ڐƋƂ̌_߂
			vector3d _nt = nv + az*dot_product(nz, nv) * nz;
			double _a = norm2(_nt);
			double b = dot_product(_nt, _r1pen) / _a;
			double c = (norm2(_r1pen) - R1*R1) / _a;
			double D = b*b - c;

			if (D > 0.0) {
				double t = -b - sqrt(D);
				vector3d  pos1 = t*nv + r_pen;					// Wnł̈ʒu
				vector3d  pos2 = fac * (pos1 - r1)/R1;	// e𗎂ƂV̂̒S_Ƃʒu
				vector3d  pos = M * pos2;

				glPointSize(5.0);
				glColor3f(1,0,0);
				glBegin(GL_POINTS);
					glVertex3dv( pos.get_pointer() );
				glEnd();
			}
		}
	}

	glPopMatrix();
}

