/**************************************************************************************************

Copyright (c) 2007   Tsunehiko Kato  and  4D2U Project, National Astronomical Observatory of Japan

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEFAvj̕擾
邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ܂Bɂ́A\tgEFA̕
gpAʁAύXAAfځAЕzATuCZXA/܂͔̔錠Aу\tgEFA
񋟂鑊ɓƂ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕɋLڂ̂Ƃ
B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂Ȃ񋟂܂B
łۏ؂Ƃ́AiA̖ړIւ̓KAьNQɂĂ̕ۏ؂܂݂܂AɌ
̂ł͂܂B ҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\t
gEFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
***************************************************************************************************/
#include  <stdio.h>
#include  "mtk_globular_clusters.h"
#include  "../common/math/random.h"
#include  "../common/graphics/color.h"
#include  "../common/astro/astrometry.h"
#include  "../common/bilingual.h"
#include  "mtk_gl_common.h"
#include  "mtk_font.h"
#include  "mtk_text.h"
#include  "mtk_switches.h"
#include  "mtk_globular_clusters.h"
#include  "mtk_approx_func.h"
#include  "mtk_our_galaxy_rt.h"
#include  "mtk_colors.h"


// Extern
extern vector3d  fixed_target_pos[6];
extern float ObjectNameSize;




//-------------------------
//  Globular Cluster data
//-------------------------
struct globular_cluster2 : public globular_cluster
{
	char		ID;
	vector3f	xyz;	// W
	RGBf	RGB;		// F
};



vector<globular_cluster2>	vGlbc;		// 󐯒c̈ʒu
vector<vector3f>			GCPT;		// 󐯒c̓_
const int GCPT_N = 500;

//  M13ƃIKc̈ʒu
float		Rh_M13;
vector3d	M13_Exyz;
vector3d	OmegaCen_Exyz;





//-------------------------
//  Globular Cluster data
//-------------------------
bool
load_globular_cluster_data(const directory& dir)
{
	FILE* fp;
	fp = dir.fopen("globular_cluster.dat", "rb");
	if (fp==NULL)  return false;


	while (true) {
		globular_cluster2 gc;
		
		//--- read data
		int count;
		count = fread(gc.name,		12,			1, fp);
		if (count < 1)	break;
		fread(&gc.eqPos.RAdeg,	sizeof(gc.eqPos.RAdeg),		1, fp);
		fread(&gc.eqPos.DEdeg,	sizeof(gc.eqPos.DEdeg),		1, fp);
		fread(&gc.distance,	sizeof(gc.distance),	1, fp);
		fread(&gc.Rc,		sizeof(gc.Rc),			1, fp);
		fread(&gc.Rh,		sizeof(gc.Rh),			1, fp);
		fread(&gc.B_V,		sizeof(gc.B_V),			1, fp);
		fread(&gc.V_R,		sizeof(gc.V_R),			1, fp);


		//--- Vʏ̈ʒuiPʔaj
		vector3f Cxyz = gc.eqPos.get_dirc_vec();

		//--- SW(pc)
		gc.xyz  = M_R2E * ( gc.distance * Cxyz );

		//--- F
		RGBf rgb;
		double  T = B_V_to_Tc(gc.B_V);
		//gc.RGB = correct_RGB( blackbody_color(T) );
		
		rgb = correct_RGB( blackbody_color(T) );
		float RGB_max = max(rgb.r, max(rgb.g, rgb.b));
		gc.RGB = rgb / RGB_max;
		//gc.RGB.R = rgb.r / RGB_max;
		//gc.RGB.G = rgb.g / RGB_max;
		//gc.RGB.B = rgb.b / RGB_max;
		

		gc.ID = 0;

		// M13̏ꍇ (idx=50)
		if (stricmp(gc.name, "NGC 6205")==0) {
            M13_Exyz  = gc.xyz;
			gc.ID = 1;

			Rh_M13 = gc.Rh;

			//***
			fixed_target_pos[0] = M13_Exyz;
		}

		// IKc̏ꍇ (idx=25)
		if (stricmp(gc.name, "NGC 5139")==0) {
            OmegaCen_Exyz  = gc.xyz;
			gc.ID = 2;
		}

		vGlbc.push_back(gc);
	}

	return  true;
}








void
init_globular_cluster_points()
{
	for (int i=0; i<GCPT_N; ++i) {
		float phi = rndUni(0,2*pi);
		float mu  = rndUni(-1,1);
		float x,y,z,rho, R;

		R = rndGauss(0, 1);

		z   = R*mu;
		rho = R*sqrt(1-mu*mu);
		x   = rho*cos(phi);
		y   = rho*sin(phi);
		
		GCPT.push_back(vector3f(x,y,z));
	}
}










//-----------
//  󐯒c
//-----------
void
draw_globular_clusters(const mtk_draw_struct& ds)
{
	const vector3d target_pos = ds.target_pos;
	const vector3d camera_pos = ds.camera.get_pos();
	const float scl_min = 4000;
	const float scl_max = 50000;
	const float scale = ds.scale;
	if (scale < scl_min)  return;

	float af = (scale > scl_max)  ?  1  :  (scale-scl_min) / (scl_max-scl_min);


	const double target_dist_sqr = norm2(target_pos - camera_pos);


	//-- For culling
	GLdouble MM[16];
	glGetDoublev( GL_MODELVIEW_MATRIX,  MM);

	glEnable(GL_BLEND);
	glDisable(GL_TEXTURE_2D);
	glDisable(GL_LIGHTING);
	glDisable(GL_DEPTH_TEST);
	glDepthMask(GL_FALSE);




	//-- Draw
	//glPointSize(1);
	glPointSize( 1.0/(ds.rad_per_pixel/0.001) );
	const float scl = 2.0f;

	const frustum frs			= ds.frs;

	const float thc   = ds.rad_per_pixel;	// PsNZ̊px
	const float thc2  = thc*thc;
	const float rate  = 10.0;				// Rh ̉{󐯒c̑傫ƌȂ


	for (int i=0; i<vGlbc.size(); ++i) {
		const globular_cluster2& gc = vGlbc[i];

		float r = gc.distance / scale;
		if (r<0.003 || r>2)  continue;

		//-- Culling
		vector3f xyz0 = gc.xyz - camera_pos;
		if ( !PointIsInside(frs, xyz0, MM) )  continue;

		//-- optical depth
		float tauR = calc_galactic_optical_depth(camera_pos, gc.xyz, 3);
		if (tauR > 3) continue;

		float _r, _g, _b;
		_r = gc.RGB.r * exp_d(tauR);
		_g = gc.RGB.g * exp_d(kpG_kpR*tauR);
		_b = gc.RGB.b * exp_d(kpB_kpR*tauR);


		//glBlendFunc(GL_ONE, GL_ONE);
		glBlendFunc(GL_SRC_ALPHA, GL_ONE);


		glPushMatrix();
		glTranslatef(xyz0.x, xyz0.y, xyz0.z);
					

		const float Rt    = rate * gc.Rh;
		const float Rt2   = Rt*Rt;
		const float dist2 = xyz0.norm2();
		if (Rt2/dist2 < thc2) {
			//--  ݊pxƂ͓_ŕ\
			const float lv = (Rt2/dist2)/thc2;
			const float c  = af * lv;
			if (c < 0.02f) {
				glPopMatrix();
				continue;
			}
			glColor3f(c*_r, c*_g, c*_b);
			glBegin(GL_POINTS);
				glVertex3f(0,0,0);
			glEnd();
		} else {
			//--  ݊px傫Ƃ͓_̏Wŕ\
			const float c = af * 0.8f;
			glColor3f(c*_r, c*_g, c*_b);
			glBegin(GL_POINTS);
				for (int j=0; j<GCPT.size(); j++) {
					vector3f xyz = scl * gc.Rh * GCPT[j];
					glVertex3fv(xyz.get_pointer());
				}
			glEnd();
		}

		// O`
		//if ((swPlanet & PLNT_NAME) && af > 0) {
		if ( test_disp_switch(DISPSW_PLANET, DISPM_NAME) && af > 0) {
			if (gc.ID != 0 || !(swStar & STAR_NAME_SELECT)) {
				const bilingual bszM13    = { "M13",	"M13" };
				const bilingual bszOmgCen = { "Omega Cen",	"{|IK}{c|}" };
				//const bilingual bszOmgCen = { " Cen",	"{|IK}{c|}" };


				float af2 = af;
					double dist_sqr = norm2(gc.xyz - target_pos);
				if (dist_sqr > 1) {
					//*** ߖT͂Ɠ
					float aa = 200*(dist_sqr / target_dist_sqr);
					float aaa= 0.5*aa - 0.3;
				
					if (aaa < 1) {
						af2 *= aaa;
					}
				}


				const RGBf& col = get_color(MTK_COLOR_NAME_OBJECT);
				glColor4f(col.r, col.g, col.b, af2);
				
				glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
			
				float R = 1.0;
				//prepare_3D_text_2(vector3f(0,0,0), R, 3.5*ds.ltf, screen_w, screen_z, false, false);
				//prepare_3D_text_2(vector3f(0,0,0), R, ObjectNameSize*ds.ltf, screen_w, screen_z, false, false);
				//prepare_3Dtext_1(R, 0, ObjectNameSize*ds.ltf, false, false);
				prepare_3Dtext_1(R, 0, ObjectNameSize*ds.ltf, 1.0f, false);


				switch (gc.ID) {
					case 0:		draw_text(gc.name);				break;
					case 1:		draw_bilingual(bszM13);			break;
					case 2:		draw_bilingual(bszOmgCen);		break;
					default:									break;
				}
			}
		}

		glPopMatrix();
	}

	glPointSize(1);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glEnable(GL_DEPTH_TEST);
	glDepthMask(GL_TRUE);
}





vector3d
get_M13_pos()
{
	return  M13_Exyz;
}


float
get_M13_half_radius()
{
	return Rh_M13;
}
