/**************************************************************************************************

Copyright (c) 2007   Tsunehiko Kato  and  4D2U Project, National Astronomical Observatory of Japan

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEFAvj̕擾
邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ܂Bɂ́A\tgEFA̕
gpAʁAύXAAfځAЕzATuCZXA/܂͔̔錠Aу\tgEFA
񋟂鑊ɓƂ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕɋLڂ̂Ƃ
B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂Ȃ񋟂܂B
łۏ؂Ƃ́AiA̖ړIւ̓KAьNQɂĂ̕ۏ؂܂݂܂AɌ
̂ł͂܂B ҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\t
gEFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
***************************************************************************************************/
#include  "mitaka.h"
#include  "mtk_minor_planets.h"
#include  "../common/astro/astro_const.h"
#include  "../common/astro/astrometry.h"
#include  "mtk_object.h"
#include  "mtk_orbital_element.h"
#include  "mtk_planets.h"
#include  "mtk_label.h"
#include  "mtk_fixed_object.h"
#include  "mtk_space_curve.h"
#include  "mtk_calc_alpha.h"
#include  "mtk_switches.h"
#include  "mtk_colors.h"
#include  "mtk_gl_common.h"
#include  "mtk_file.h"
#include  <vector>
#include  <map>

//*********
void	set_side_light(const mtk_draw_struct& ds);
extern float ObjectNameSize, DwarfPlanetNameSize, SmallObjectNameSize;
extern float OrbitWidth;
//*********


//------------------
//  fт̃x
//------------------
const bilingual bszMinorPlanetLabel = { "Asteroid Belt", "{f|傤킭}{|}" };
const vector3d  minor_planet_label_pos( 2.5*_1AU_pc, 0, 0 );

//-----------------
//  Small objects
//-----------------
struct  small_object
{
	int  type;				// ^Cv
	int  no;				// fԍ
	int  label_idx;			// x̃CfbNX
	int  phys_param_idx;
	bool bDwarfPlanet;		// Dwarf planet 
	bool bSelected;			// IĂ邩
	orbital_elements  oe;	// Ovf
};

static std::vector<small_object>	vSmallObjects;


//-------------------------------------------
//  fԍƏV̂̃CfbNX̎Qƃe[u
//-------------------------------------------
static map<long, long>		minor_planet_number_table;		


//----------------------------
//  Small objects Phys param
//----------------------------
struct  small_object_info
{
	int mp_no;				// minor planet number
	double Rx, Ry, Rz;		// size
	double B_V;				// B_V color
};

static small_object_info vSmoi[] = {
	{ 136199, 1200, 1200, 1200, 0.71 },		//  Eris
	{ 136108, 1000,  600,  500, 0.63 },		//  2003 EL61
	{  90377,  900,  900,  900, 1.23 },		//  Sedna
	{ 136472,  750,  750,  750, 0.9  },		//  2005 FY9
	{  90482,  500,  500,  500, 0.68 },		//  Orcus
	{  50000,  500,  500,  500, 0.94 },		//  Quaoar
	{  20000,  300,  300,  300, 0.85 }		//  Varuna
};
const int smo_phys_info_num = sizeof(vSmoi)/sizeof(vSmoi[0]);


// ǂݍ
int
load_small_objects(FILE* fp, int type)
{
	while (true) {
		long	no;
		double	epoch;
		float	a, e, M0, n, node, i, omg;

		//--- read data
		int count;
		count = fread(&no,	sizeof(no),			1, fp);
		if (count < 1)	break;
		fread(&epoch,	sizeof(epoch),		1, fp);
		fread(&M0,		sizeof(M0),			1, fp);
		fread(&omg,		sizeof(omg),		1, fp);
		fread(&node,	sizeof(node),		1, fp);
		fread(&i,		sizeof(i),			1, fp);
		fread(&e,		sizeof(e),			1, fp);
		fread(&n,		sizeof(n),			1, fp);
		//
		a = pow(0.985607669/n, 2.0/3.0);
		//
		small_object  smo;
		smo.type			= type;
		smo.no				= no;
		smo.label_idx		= -1;
		smo.phys_param_idx	= -1;
		smo.bDwarfPlanet	= false;
		smo.bSelected		= false;
		smo.oe.set_parameters(epoch, a, e, M0, n, node, i, omg);
		vSmallObjects.push_back(smo);
		//--  fԍƂ̎Qƕ\  --
		int idx = vSmallObjects.size() - 1;
		minor_planet_number_table.insert( pair<long,long>(no, idx) );
	}

	//---  ufсṽx̓o^
	int fixed_obj_idx = add_fixed_object( minor_planet_label_pos, OBJ_TYPE_SMALL_OBJECT );
	mtk_object obj = mtk_object(OBJ_TYPE_FIXED_OBJECT, fixed_obj_idx, 0.0f);
	register_object(obj);
	bilingual  name = bszMinorPlanetLabel;
	float thc = 10 * D2R;
	int label_idx = add_label( name.text_J, name.text_E, obj, MTK_COLOR_NAME_OBJECT, 1.0f, ObjectNameSize, 0, thc );
	obj.init(OBJ_TYPE_LABEL, label_idx, 0.0f);
	register_object(obj);
	
	//---  `̓o^
	for (int i=0; i<smo_phys_info_num; i++) {
		int idx = get_small_object_index( vSmoi[i].mp_no );
		if (idx == -1)  continue;
		small_object&  smo = vSmallObjects[idx];
		smo.phys_param_idx = i;
	}

	return  vSmallObjects.size();
}


void
register_small_objects()
{
	mtk_object  obj;
	for (int i=0; i<smo_phys_info_num; i++) {	//***

		//--  register satellites
		int idx = get_small_object_index( vSmoi[i].mp_no );
		obj.init(OBJ_TYPE_SMALL_OBJECT, idx, 0.0f);
		register_object(obj);
	}
}


void
register_small_objects_orbit_curves()
{
	const int N = vSmallObjects.size();

	for (int i=0; i<N; i++) {
		const small_object&  smo = vSmallObjects[i];
		if ( smo.label_idx == -1 )  continue;	// xׂ̂

		int color_no = (smo.bDwarfPlanet)  ?  MTK_COLOR_ORBIT_DWARF_PLANET  :  MTK_COLOR_ORBIT_SMALL_OBJECT;
		space_curve  sc( mtk_object(OBJ_TYPE_SMALL_OBJECT, i, 0.0f), OrbitWidth, color_no );
		register_space_curve( sc );
	}
}

void
make_small_objects_orbit_curve(space_curve& sc, int div_N)
{
	const small_object&  smo = vSmallObjects[sc.get_related_object().get_index()];

	sc.clear();
	for (int j=0; j<div_N; j++) {
		double phi = 2.0 * M_PI * double(j) / div_N;
		sc.add_point( double(_1AU_pc) * smo.oe.calc_orbit_pos(phi) );
	}
}

float
get_small_object_label_alpha(const mtk_draw_struct& ds, int idx)
{
	const int type = get_small_object_type(idx);
	const float dscl = (type == SMALLOBJ_TYPE_MINOR_PLANETS) ? 3.0 * _1AU_pc : 60.0 * _1AU_pc;
	float  alp;
	
	vector3d  tpos = get_target_center_pos();
	if (norm( get_small_object_position(idx) - tpos ) > 10000*_1km_pc) {
		alp = calc_alpha_by_disapear_scale_inside( ds.scale, dscl );
	} else {
		alp = 1;
	}

	const vector3d  rpos = get_small_object_position( idx ) - ds.camera.get_pos();
	float  Rv = calc_visible_radius_small_object( idx );

	return  alp * calc_alpha_by_apparent_diameter( rpos, Rv, 10 * D2R );
}

float
get_small_object_orbit_alpha(const mtk_draw_struct& ds, int idx)
{
	const int type = get_small_object_type(idx);
	const float dscl = (type == SMALLOBJ_TYPE_MINOR_PLANETS) ? 3.0 * _1AU_pc : 60.0 * _1AU_pc;
	float  alp;
	
	vector3d  tpos = get_target_center_pos();
	if (norm( get_small_object_position(idx) - tpos ) > 10000*_1km_pc) {
		alp = calc_alpha_by_disapear_scale_inside( ds.scale, dscl );
	} else {
		alp = calc_alpha_by_disapear_scale_inside( ds.scale, 1000000*_1km_pc );
	}

	const vector3d  rpos = get_small_object_position( idx ) - ds.camera.get_pos();
	float  Rv = calc_visible_radius_small_object( idx );

	return  alp * calc_alpha_by_apparent_diameter( rpos, Rv, 10 * D2R );
}


//---------
//  index
//---------
int
get_small_object_index(int minor_planet_number)
{
	map<long, long>::iterator it = minor_planet_number_table.find( minor_planet_number );
	if (it==minor_planet_number_table.end())  return -1;	// no match
	return  it->second;
}

int
get_small_objects_num()
{
	return  vSmallObjects.size();
}

void
update_small_objects_position(const double& t)
{
	for (std::vector<small_object>::iterator it=vSmallObjects.begin(); it != vSmallObjects.end(); it++) {
		it->oe.calc_pos(t);
	}
}

vector3d
get_small_object_position(int idx)
{
	return double(_1AU_pc) * vSmallObjects[idx].oe.get_pos();
}

int
get_small_object_type(int idx)
{
	return  vSmallObjects[idx].type;
}

bool
is_small_object_selected(int idx)
{
	return  vSmallObjects[idx].bSelected;
}

int
get_small_object_label_index(int idx)
{
	return  vSmallObjects[idx].label_idx;
}

void
get_small_object_size(int idx, double& Rx, double& Ry, double& Rz)
{
	int  pi_idx = vSmallObjects[idx].phys_param_idx;
	if (pi_idx == -1)  {
		Rx = Ry = Rz = 0.0;
		return;
	}

	Rx = vSmoi[pi_idx].Rx;
	Ry = vSmoi[pi_idx].Ry;
	Rz = vSmoi[pi_idx].Rz;
}

//--------
//  Draw
//--------
void
draw_a_small_object0(int idx)
{
	int  pi_idx = vSmallObjects[idx].phys_param_idx;
	if (pi_idx == -1)  return;

	//--  material
	RGBf  col = correct_RGB( blackbody_color( B_V_to_Tc( vSmoi[pi_idx].B_V ) ) );
	float mat[4];
	mat[0] = col.r;
	mat[1] = col.g;
	mat[2] = col.b;
	mat[3] = 1;
	glMaterialfv( GL_FRONT_AND_BACK, GL_DIFFUSE, mat );
	mat[0] *= 0.5;
	mat[1] *= 0.5;
	mat[2] *= 0.5;
	glMaterialfv( GL_FRONT_AND_BACK, GL_AMBIENT, mat );

	glEnable( GL_LIGHTING );
	glEnable( GL_LIGHT0 );
	glEnable(GL_CULL_FACE);
	glEnable(GL_DEPTH_TEST);
	glEnable(GL_NORMALIZE);

	gl_draw_LOD_sphere();
}

void
draw_a_small_object(const mtk_draw_struct& ds, int idx, vector3d rpos, double scl)
{
	int  pi_idx = vSmallObjects[idx].phys_param_idx;
	if (pi_idx == -1)  return;

	vector3d  pos = get_small_object_position( idx );
	double Rx, Ry, Rz;
	Rx = vSmoi[pi_idx].Rx * scl * _1km_pc;
	Ry = vSmoi[pi_idx].Ry * scl * _1km_pc;
	Rz = vSmoi[pi_idx].Rz * scl * _1km_pc;

	double th_view = 2 * Rx / rpos.norm();
	double rpp = ds.rad_per_pixel;
	if (th_view < rpp)  return;

	glPushMatrix();
		glTranslatef(rpos.x, rpos.y, rpos.z);
		glScalef(Rx, Ry, Rz);
		if (!bSideLight)	set_light_from_sun(pos);
		else				set_side_light(ds);
		draw_a_small_object0(idx);
	glPopMatrix();
}

void
draw_small_objects_points(const mtk_draw_struct& ds, const float sz0, const float af0)
{
	glPushAttrib(GL_ENABLE_BIT);
	glEnable(GL_BLEND);
	glDisable(GL_TEXTURE_2D);
	glDisable(GL_LIGHTING);

	float af0_2 = af0;
	float sz = sz0 / (ds.rad_per_pixel / 0.001);
	if (sz < 1) {
		af0_2 *= sz;
		sz = 1;
	}

	glPointSize(sz);
	const int N = vSmallObjects.size();
	for (int i=0; i<N; ++i) {
		int type = vSmallObjects[i].type;
		switch (type) {
			case SMALLOBJ_TYPE_MINOR_PLANETS:
				if ( !test_disp_switch(DISPSW_MINOR_PLANET, DISPM_DISP) )  continue;
				break;
			case SMALLOBJ_TYPE_TNOS:
				if ( !test_disp_switch(DISPSW_TNO, DISPM_DISP) )  continue;
				break;
			default:	break;
		}

		const orbital_elements& oe = vSmallObjects[i].oe;

		// V̂̈ʒu
		vector3d  pos = double(_1AU_pc) * oe.get_pos();

		// x̐ݒ
		const float R1 = 0.01;
		const float R2 = 0.04;
		const float R3 = 1;
		const float R4 = 4;
		float R = norm(pos) / ds.scale;
		if (R < R1 || R > R4) continue;

		float af = af0_2;
		if (R < R2)			{ af *= (R-R1)/(R2-R1); }
		else if (R > R3)	{ af *= 1 - (R-R3)/(R4-R3); }
		if (af < 0.05)  continue;

		// xvZ
		const vector3f  lv_e = normalize(-pos);		// vf̌xNg
		const vector3f  nv = normalize(ds.camera.get_pos() - pos);
		float dp = dot_product(lv_e, nv);
		float th = acosf(dp);
		float frac = 1.0 - th / M_PI;

		// F̌
		float lv = 0.5 * frac + 0.5;
		glColor4f(lv, lv*0.95, lv*0.95, af);
		glBegin(GL_POINTS);
			glVertex3dv(pos.get_pointer());
		glEnd();
	}

	glPopAttrib();
}

void
draw_small_objects(const mtk_draw_struct& ds)
{
	const float scale = ds.scale;
	if (100*_1AU_pc/scale < 0.002)  return;

	float af0 = 1;
	float c = 4.0;
	float l = c * _1AU_pc / scale;
	if (l >= 1)  return;
	if (l>0.2 && l<1)  { float t = (l-0.2)/(1-0.2); af0 *= 1-t; }

	glEnable(GL_BLEND);

	// f̕\
	glPushMatrix();
		const vector3d camera_pos = ds.camera.get_pos();
		glTranslatef(-camera_pos.x, -camera_pos.y, -camera_pos.z);
		
		draw_small_objects_points(ds, 1.9f, af0);
	glPopMatrix();

	glPointSize(1.0f);
}

//------------------
//  visible radius
//------------------
double
calc_visible_radius_small_object(int idx)
{
	return  double(_1AU_pc) * vSmallObjects[idx].oe.get_a();
}

//----------------
//  O̓ǂݍ
//----------------
void
load_small_object_names(FILE* fp)
{
	const int BUF_SIZE = 80;
	char buf[BUF_SIZE], buf2[BUF_SIZE];
	char name_E[20], name_J[40];

	while (true) {
		int no;
		
		//-- Read one line
		if ( !read_one_line(fp, buf, BUF_SIZE) )  break;
		//-- Minor planet number
		if ( !extract_string(buf, 0, 6, buf2) ) continue;
		sscanf(buf2, "%ld", &no);
		//-- Name (English / Japanese)
		bool res_E, res_J;
		res_E = extract_string(buf, 10, 28, name_E);
		res_J = extract_string(buf, 30, 50, name_J);
		if (!res_E)		continue;
		if (!res_J)		strcpy(name_J, name_E);
		//--  Minor planet index
		int  idx = get_small_object_index( no );
		if (idx < 0)  continue;
		//-- Flag
		small_object&  smo = vSmallObjects[idx];
		smo.bDwarfPlanet = (buf[8] == 'D');
		smo.bSelected    = (buf[9] != ' ');
		//--  Register label
		float R   = 1.4 * 1000 * _1km_pc;

		float thc = 10 * D2R;
		int color_no;
		float name_size;
		if (smo.bDwarfPlanet) {
			color_no  = MTK_COLOR_NAME_DWARF_PLANET;
			name_size = DwarfPlanetNameSize;
		} else {
			color_no  = MTK_COLOR_NAME_SMALL_OBJECT;
			name_size = SmallObjectNameSize;
		}
		
		int label_idx = add_label( name_J, name_E, mtk_object(OBJ_TYPE_SMALL_OBJECT, idx, 0.0f), color_no, 1.0f, name_size, R, thc );
		mtk_object obj;
		obj.init(OBJ_TYPE_LABEL, label_idx, 0.0f);
		register_object(obj);

		smo.label_idx = label_idx;
	}
}
