/**************************************************************************************************

Copyright (c) 2007   Tsunehiko Kato  and  4D2U Project, National Astronomical Observatory of Japan

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEFAvj̕擾
邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ܂Bɂ́A\tgEFA̕
gpAʁAύXAAfځAЕzATuCZXA/܂͔̔錠Aу\tgEFA
񋟂鑊ɓƂ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕɋLڂ̂Ƃ
B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂Ȃ񋟂܂B
łۏ؂Ƃ́AiA̖ړIւ̓KAьNQɂĂ̕ۏ؂܂݂܂AɌ
̂ł͂܂B ҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\t
gEFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
***************************************************************************************************/
#include  "mtk_network_mode.h"
#include  "../common/graphics/gl_win.h"
#include  "../common/frame_rate.h"
#include  "mitaka.h"
#include  "mtk_switches.h"
#include  "mtk_dialog_box.h"
#include  "mtk_make_movie.h"
#include  "mtk_window_mode.h"
#include  "mtk_menu_bar.h"
#include  "mtk_time.h"
#include  "mtk_camera.h"
#include  "mtk_camera_setting.h"
#include  "mtk_directory.h"
#include  "mtk_tcp.h"
#include  "mtk_movie.h"
#include  "resource.h"


//-----------
//  Externs
//-----------
extern HINSTANCE	g_hInst;
extern HWND			g_hWnd;
extern HCURSOR		hCursorArrow;
extern COpenGL		ogl;
extern int			win_w, win_h, win_w0, win_h0;
extern int			win_x0, win_y0;
extern int			gl_x0, gl_y0, gl_w, gl_h;
extern char			tyMode;
extern fps_counter  FrmCounter;
extern bool			bMotion;
extern mtk_camera	g_camera;
extern char			szAppName[];
extern bool			bDrawLowRes;
extern int			win_mgn_w1, win_mgn_h1;
extern int			win_mgn_w2, win_mgn_h2;
extern MediaFiles	MVF, IMGF, AUDF;
extern	movie  dsmv;


void	init();
void	init_menu();
void	OnCommandSignal();
void	ClearSignal();
bool	GetSignal();
void	WaitForSignal();
void	OnBaseCameraOri(quaterniond ori);
void	draw();
void	OnCreate(HWND hWnd);
void	OnDestroy();
void	OnSize(HWND hWnd);
void	OnActivate(WPARAM wParam);
void	OnDirectShowEvent();
int		OnKeyDown(HWND hWnd, WPARAM wParam);
void	OnTakeoff();
void	OnLanding();
void	OnChangeTime(const double& JD);
void	process_zoom(const float& _zm);


//--  Network
bool	bNetwork = false;	// ʐM邩ǂ
bool	bControler = false; // Rg[[
//--  Draw
bool bDraw				= false;	// `stO
bool bDrawing			= false;	// `s̃tO



//========
//  Draw
//========
void
Draw_NetworkMode()
{
	draw();
}

void
OnDraw_NetworkMode(HDC hDC)
{
	if (bMovieMode) {
		dsmv.OnPaint(g_hWnd, hDC);
		return;
	}

	bDrawing = true;
	FrmCounter.begin_frame();
	ogl.MakeCurrent(hDC);
		Draw_NetworkMode();
		BOOL res;
		res = SwapBuffers(hDC);
	ogl.MakeCurrent(NULL);
	FrmCounter.end_frame();
	bDrawing =false;
}

void
OnCommandDraw_LowRes()
{
	if (bControler)  { send_command(COMMAND_DRAW_LOWRES); }
	bDraw = true;
	bDrawLowRes = true;
}

void
OnCommandDraw_HighRes()
{
	if (bControler)  { send_command(COMMAND_DRAW_HIGHRES); }
	bDraw = true;
	bDrawLowRes = false;
}

void
OnCommandDraw()
{
	if (bControler || !bNetwork) {
		if (bMotion)	{ OnCommandDraw_LowRes(); }
		else			{ OnCommandDraw_HighRes(); }
	}

	//***********
	if (!bNetwork) {
		InvalidateRect(g_hWnd, NULL, false);
	}
}


//--------
//  Size
//--------
// EBhETCYς
void
Reshape_NetworkMode(int w, int h)
{
	if (w==0 || h==0)  return;
	set_trackball_area(win_w0, win_h0);
	glViewport(gl_x0, gl_y0, gl_w, gl_h);
}

void
OnSize_NetworkMode(HWND hWnd)
{
	int  w, h;
	RECT  rt;
	GetClientRect(hWnd, &rt);
	w = rt.right  - rt.left;
	h = rt.bottom - rt.top;

	SetScreenButtonSize(w, h);

	//
	HDC  hDC = GetDC(hWnd);
	ogl.MakeCurrent(hDC);
		Reshape_NetworkMode(w, h);
	ogl.MakeCurrent(NULL);
	ReleaseDC(hWnd, hDC);
}


//====================
//  Window Procedure
//====================
LRESULT CALLBACK
WndProc_NetworkMode(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	HDC hDC;
	PAINTSTRUCT ps;
	
	switch (msg) {
	case WM_CREATE:
		OnCreate(hWnd);
		return 0;
	case WM_COMMAND:
		if (process_menu_command(hWnd, LOWORD(wParam)))  {
			OnCommandDraw();
			return 0;
		}
		break;
	case WM_INITMENUPOPUP:
		process_menu_checks(wParam);
		break;
	case WM_PAINT:
		hDC = BeginPaint(hWnd, &ps);
			//--- OnDraw(hDC); ---
		EndPaint(hWnd, &ps);
		OnCommandDraw();
		return 0;
	case WM_SIZE:
		OnSize_NetworkMode(hWnd);
		return 0;
	case WM_ACTIVATE:
		OnActivate(wParam);
		return 0;
	case WM_LBUTTONDOWN:
		OnLB( LOWORD(lParam), HIWORD(lParam), MOUSE_DOWN, wParam );
		return 0;
	case WM_LBUTTONUP:
		OnLB( LOWORD(lParam), HIWORD(lParam), MOUSE_UP, wParam );
		return 0;
	case WM_RBUTTONDOWN:
		OnRB( LOWORD(lParam), HIWORD(lParam), MOUSE_DOWN, wParam );
		return 0;
	case WM_RBUTTONUP:
		OnRB( LOWORD(lParam), HIWORD(lParam), MOUSE_UP, wParam );
		return 0;
	case WM_MOUSEMOVE:
		OnMove( LOWORD(lParam), HIWORD(lParam), wParam );
		return 0;
	case WM_MBUTTONUP:
		// E
		switch (tyMode) {
			case MODE_PLANETARIUM:	OnTakeoff();	break;
			case MODE_HIPPARCOS:	OnLanding();	break;
			default:								return 0;
		}
		OnCommandDraw();
		return 0;
	case WM_MOUSEWHEEL:
		OnMouseWheel( (short)HIWORD(wParam) );
		return 0;
	case WM_LBUTTONDBLCLK:
		OnLBDBLCLK(LOWORD(lParam), HIWORD(lParam));
		return 0;
	case WM_KEYDOWN:
		if (OnKeyDown(hWnd, wParam)==0)  return 0;
		break;
	case WM_SETCURSOR:
		POINT pos;
		GetCursorPos(&pos);
		ScreenToClient(hWnd, &pos);
		if (pos.x >= win_mgn_w1 && pos.x < win_mgn_w1 + win_w
			&& pos.y >= win_mgn_h1 && pos.y < win_mgn_h1 + win_h) {
			SetCursor(NULL);
			return 0;
		}
		break;	// ftHg̃J[\
	case WM_ERASEBKGND:
		return 0;
	case WM_GRAPHNOTIFY:
		OnDirectShowEvent();
		return 0;
	case WM_DESTROY:
		OnDestroy();
		PostQuitMessage(0);
		return 0;
	}	
	return  DefWindowProc(hWnd , msg , wParam , lParam);
}


//--------
//  Init
//--------
void
init_network_mode()
{
	//--  
	init();

	//--  TCP ̏
	SetSplashText("lbg[Nڑҋ@...", "Waiting for Network Connection...");
	init_TCP(bControler);

	//--  fBAEWȂǂ̏𓯊  --//
	ClearSignal();
	if (bControler) {
		//--- Media info file ij[Oɏj---
		directory  dir = get_directory(DIR_MEDIA);
		MVF.open_info_file(dir, "movies.dat");
		IMGF.open_info_file(dir, "images.dat");
		AUDF.open_info_file(dir, "audio.dat");

		for (int i=0; i<MVF.size(); i++) {
			media_file_info& mfi = MVF[i];
			send_media_title(mfi.type, mfi.menu_title, mfi.disp_title);
		}
		for (int i=0; i<IMGF.size(); i++) {
			media_file_info& mfi = IMGF[i];
			send_media_title(mfi.type, mfi.menu_title, mfi.disp_title);
		}
		for (int i=0; i<AUDF.size(); i++) {
			media_file_info& mfi = AUDF[i];
			send_media_title(mfi.type, mfi.menu_title, mfi.disp_title);
		}

		{
			set_base_camera( quaterniond(1,0,0,0) );
			FILE* fp = fopen("base.cfg", "rt");
			if (fp != NULL) {
				load_base_camera_setting(fp);
				fclose(fp);
			}

			OnBaseCameraOri( get_base_camera_ori() );
		}

		OnCommandSignal();
	} else {
		WaitForSignal();
	}

	//--- setup menu ---
	init_menu();

	//--  ݒ肵Ȃ
	if (bControler) {
		OnChangeTime( get_time_JD() );
	}
}


//=============
//  Main Loop
//=============
int
Main_NetworkMode( HINSTANCE hInstance, int iCmdShow )
{
	//-----------------------
	//  EBhENX̓o^
	//-----------------------
	g_hInst = hInstance;

	WNDCLASS	wndclass;
	wndclass.style			= CS_HREDRAW | CS_VREDRAW | CS_DBLCLKS;
	wndclass.lpfnWndProc	= WndProc_NetworkMode;
	wndclass.cbClsExtra		= 0;
	wndclass.cbWndExtra		= 0;
	wndclass.hInstance		= hInstance;
	wndclass.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_MITAKA_ICON) );
	wndclass.hCursor		= hCursorArrow;
	wndclass.hbrBackground	= (HBRUSH)GetStockObject(BLACK_BRUSH);
	wndclass.lpszMenuName	= NULL;
	wndclass.lpszClassName	= szAppName;
	if (!RegisterClass(&wndclass)) {
		MessageBox(NULL, TEXT("This program requires WindowsNT!"), szAppName, MB_ICONERROR);
		return 0;
	}

	//--- XvbVEBhEN ---
	CreateSplashWindow();

	//-- init data and view
	init_network_mode();

	//--- window size/pos ---
	DWORD  dwStyle;
	dwStyle = WS_VISIBLE|WS_POPUP;

	//--- Create window ---
	HWND hWnd;
	hWnd = CreateWindowEx(
						WS_EX_TOPMOST,
						szAppName,
						szAppName,							// window caption
						dwStyle,							// window style
						win_x0, win_y0,						// window position
						win_w0, win_h0,						// window size
						NULL,								// parent window handle
						NULL,								// window menu handle
						hInstance,							// program instance handle
						NULL);								// creation parameters

	if (hWnd == NULL) {
		MessageBox(NULL, TEXT("EBhE쐬ł܂ł"), szAppName, MB_ICONERROR);
		return 0;
	}

	//------------------
	//  EBhE̕\
	//------------------
	ShowWindow(hWnd, iCmdShow);
	UpdateWindow(hWnd);
	SetForegroundWindow(hWnd);
	SetCursorPos(0, 0);

	//--- XvbVEEBhE ---
	DestroySplashWindow();

	//---  XN[Z[o[It ---
	SystemParametersInfo(SPI_SETSCREENSAVEACTIVE, FALSE, NULL, SPIF_SENDCHANGE);

	//-------------
	//  main loop
	//-------------
	MSG msg;
	while (true) {

		if (PeekMessage(&msg, NULL, 0,0, PM_REMOVE))  {
			if (msg.message == WM_QUIT)  break;
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		} else if (bDraw) {
			HDC  hDC = GetDC(hWnd);
			bDraw = false;
			OnDraw_NetworkMode(hDC);
			ReleaseDC(hWnd, hDC);
		} else if (bRecordMovie) {
			HDC  hDC = GetDC(hWnd);
			OnDraw_NetworkMode(hDC);
			ReleaseDC(hWnd, hDC);
		} else {
			Sleep(1);
		}
	}

	return 0;
}
