/**************************************************************************************************

Copyright (c) 2007   Tsunehiko Kato  and  4D2U Project, National Astronomical Observatory of Japan

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEFAvj̕擾
邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ܂Bɂ́A\tgEFA̕
gpAʁAύXAAfځAЕzATuCZXA/܂͔̔錠Aу\tgEFA
񋟂鑊ɓƂ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕɋLڂ̂Ƃ
B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂Ȃ񋟂܂B
łۏ؂Ƃ́AiA̖ړIւ̓KAьNQɂĂ̕ۏ؂܂݂܂AɌ
̂ł͂܂B ҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\t
gEFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
***************************************************************************************************/
#ifndef __MTK_OBJECT_H__
#define __MTK_OBJECT_H__
#include  "../common/math/vector3.h"

#include  "mtk_draw_struct.h"



//---------------
//  Object Type
//---------------
enum {
	OBJ_TYPE_NONE,
	OBJ_TYPE_SUN,
	OBJ_TYPE_PLANET,
	OBJ_TYPE_SATELLITE,
	OBJ_TYPE_SMALL_OBJECT,
	OBJ_TYPE_STAR,
	OBJ_TYPE_NEARBY_GALAXY,
	OBJ_TYPE_DISTANT_GALAXY,
	OBJ_TYPE_SPACECRAFT,
	OBJ_TYPE_OORT_CLOUD,

	OBJ_TYPE_FIXED_OBJECT,
	OBJ_TYPE_SCALE_CIRCLE,
	OBJ_TYPE_LABEL
};



//--------------------
//  class mtk_object
//--------------------
class  mtk_object
{
	int  m_type, m_idx;
	float m_dz;	// _Wnł̂炵

public:
	mtk_object() : m_dz(0.0f) {};
	mtk_object(int type, int idx, float dz) { init(type, idx, dz); }

	void	init(int type, int idx, float dz);

	int			get_type() const  { return  m_type; }
	int			get_index() const { return  m_idx; }
	vector3d	get_pos() const;
	float		get_dz() const		{ return m_dz; }

	bool		is_visible() const;
	double		get_bounding_R(const mtk_draw_struct& ds) const;

	void		draw(const mtk_draw_struct& ds) const;
};






//==========
//  Object
//==========
void	init_objects();

void	clear_objects();
void	register_object(const mtk_object& obj);

void	draw_objects(const mtk_draw_struct& ds);


//
//
//
float	get_label_alpha(const mtk_draw_struct& ds, const mtk_object& obj);
float	get_orbit_alpha(const mtk_draw_struct& ds, const mtk_object& obj);
bool	is_object_label_visible(const mtk_object& obj);
bool	is_object_orbit_visible(const mtk_object& obj);



#endif
