/**************************************************************************************************

Copyright (c) 2007   Tsunehiko Kato  and  4D2U Project, National Astronomical Observatory of Japan

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEFAvj̕擾
邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ܂Bɂ́A\tgEFA̕
gpAʁAύXAAfځAЕzATuCZXA/܂͔̔錠Aу\tgEFA
񋟂鑊ɓƂ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕɋLڂ̂Ƃ
B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂Ȃ񋟂܂B
łۏ؂Ƃ́AiA̖ړIւ̓KAьNQɂĂ̕ۏ؂܂݂܂AɌ
̂ł͂܂B ҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\t
gEFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
***************************************************************************************************/
#include  "mtk_place_name.h"
#include  "../common/graphics/gl_common.h"
#include  "../common/graphics/gltext.h"
#include  "mtk_gl_common.h"
#include  "mtk_colors.h"
const float D2Rf = 3.14159265f/180.0f;



const char* szLocationNameSizeDef	= "3.2";
float LocationNameSize;


void
PlaceName::add_place(const PlaceNameItem& pni)
{
	vPlace.push_back(pni);
}



//------------
//  Ԃ̐ݒ
//------------
void
PlaceName::set_state(char group, char state)
{
	for (int i=0; i<vPlace.size(); i++) {
		PlaceNameItem& pni = vPlace[i];
		if (pni.group == group) {
			pni.state = state;
		}
	}
}

void
PlaceName::set_alpha(char group, float alp)
{
	for (int i=0; i<vPlace.size(); i++) {
		PlaceNameItem& pni = vPlace[i];
		if (pni.group == group) {
			pni.alp = alp;
		}
	}
}

void
PlaceName::set_label_alpha(char group, float alp)
{
	for (int i=0; i<vPlace.size(); i++) {
		PlaceNameItem& pni = vPlace[i];
		if (pni.group == group) {
			pni.label_alp = alp;
		}
	}
}

void
PlaceName::enable_label(char group, bool bDispLabel)
{
	for (int i=0; i<vPlace.size(); i++) {
		PlaceNameItem& pni = vPlace[i];
		if (pni.group == group) {
			pni.bDispLabel = bDispLabel;
		}
	}
}


//------------------
//  GtFNg̕]
//------------------
void
PlaceName::evalutate_effect(float t)
{
	for (int i=0; i<vEffect.size(); i++) {
		const pn_effect& pnef = vEffect[i];
		if (t < pnef.frame1 || t > pnef.frame2)  continue;

		for (int j=0; j<vPlace.size(); j++) {
			const PlaceNameItem& pni = vPlace[j];
			if (pni.group != pnef.group)   continue;

			char group = pnef.group;
			switch (pnef.ty) {
				case PNEFFECT_FADEIN:
					{
						float alp = (t - pnef.frame1) / (pnef.frame2 - pnef.frame1);
						set_alpha(group, alp);
					}
					break;
				case PNEFFECT_FADEOUT:
					{
						float alp = (pnef.frame2 - t) / (pnef.frame2 - pnef.frame1);
						set_alpha(group, alp);
					}
					break;
				case PNEFFECT_BLINK:
					{
						char state;
						state = (((int(t)-pnef.frame1)/3)%2  == 0)  ?  PNSTATE_FLUSH  :  PNSTATE_ON;
						set_state(group, state);
					}
					break;
				case PNEFFECT_ENABLE_LABEL:
					enable_label(group, true);
					break;
				case PNEFFECT_DISABLE_LABEL:
					enable_label(group, false);
					break;
				case PNEFFECT_FADEIN_LABEL:
					{
						float alp = (t - pnef.frame1) / (pnef.frame2 - pnef.frame1);
						set_label_alpha(group, alp);
						enable_label(group, true);
					}
					break;
				case PNEFFECT_FADEOUT_LABEL:
					{
						float alp = (pnef.frame2 - t) / (pnef.frame2 - pnef.frame1);
						set_label_alpha(group, alp);
						enable_label(group, true);
					}
					break;

				case PNEFFECT_NORMAL:
				default:
					set_state(group, PNSTATE_ON);
					break;
			}
		}
	}
}




void
PlaceName::draw_on_TopoSphere(const TopoSphere& tp, float screen_w, float screen_z, wgl_font& fnt, bool bEng, float ltf)  const
{
	const float thr1    = 1.5 * D2Rf;
	const float thr2    = 2.5 * D2Rf;
	const float thr1sqr = thr1*thr1;
	const float thr2sqr = thr2*thr2;
	const double fac = 0.0005;   //***
	const float R0 = tp.get_R0();

	glDisable(GL_LIGHTING);
	glDisable(GL_TEXTURE_2D);
	glEnable(GL_BLEND);


	float M[16];
	vector3f  rc;
	glGetFloatv( GL_MODELVIEW_MATRIX, M);
	rc.x = M[12];
	rc.y = M[13];
	rc.z = M[14];

	const float R2 = M[0]*M[0] + M[1]*M[1] + M[2]*M[2];


	gltext  txt;
	for (int i=0; i<vPlace.size(); i++) {
		const PlaceNameItem&  pni = vPlace[i];

		if (pni.state == PNSTATE_OFF)  continue;

		vector3f  r = 1.002f * tp.get_pos(pni.lon, pni.lat);
		
		glPushMatrix();
			glPushMatrix();
				glTranslatef(r.x, r.y, r.z);
				glGetFloatv( GL_MODELVIEW_MATRIX, M);
			glPopMatrix();
			float L2 = M[12]*M[12] + M[13]*M[13] + M[14]*M[14];
			float th1_2 = R2 * pni.R1*pni.R1 / L2;

			if (th1_2 > thr1sqr) {
				float af = (th1_2 - thr1sqr) / (thr2sqr - thr1sqr);
				if (af > 1.0f)  af = 1.0f;

				// ߂ꍇtF[hAEg
				if (L2/R2 < 0.01) {
					af *= (L2/R2)/(0.01*0.01);
				}

				if (af > 0.05) {

					//-- |C^
					draw_pointer(tp, pni, af*pni.alp);
					
					if (pni.bDispLabel) {
						//-- O
						r *= (1+fac);
						glTranslatef(r.x, r.y, r.z);

						af *= pni.label_alp;
						switch (pni.ty) {
							case 1:		glColor4f(0.7,0.8,0.9, 0.8f*af);	break;
							case 0:
							case 2:
							default:
								const RGBf& col = get_color(MTK_COLOR_LOCATION_NAME);
								glColor4f(col.r, col.g, col.b, af);
								break;
						}

						float fnt_sz = LocationNameSize * pni.size * ltf / 1.2;
						prepare_3Dtext_2(rc, 0, fnt_sz, screen_w, screen_z, false, true);
						
						gltext  txt;
						if (bEng)	{ txt.set_text(pni.bszName.text_E); }
						else		{ txt.set_text(pni.bszName.text_J); }

						switch (pni.align) {
							case 'l':	glTranslatef(0,-1,0);	//-- through down --//
							case 'L':	txt.draw_right(0, fnt);					break;
							case 'D':	glTranslatef(0.2,-1,0);	txt.draw(fnt);	break;
							default:	glTranslatef(0.2,0,0);	txt.draw(fnt);	break;
						}
					}
				}
			}
		glPopMatrix();
	}
}



//------------------------
//  xp̃|C^\
//------------------------
void
PlaceName::draw_pointer(const TopoSphere& tp, const PlaceNameItem& pni, const float& af)  const
{
	if (pni.ty != 2) {
		switch (pni.ty) {
			default:
			case 0:		glPointSize(5.0);	glColor4f(1,0,0,af);		break;
			case 1:		glPointSize(4.0);	glColor4f(0.2,0.5,1,af);	break;
		}
		glBegin(GL_POINTS);
			glVertex3f(0,0,0);
		glEnd();
		return;
	}

	vector3d  r1 = tp.get_pos(pni.lon, pni.lat);
	vector3d  r2 = 1.005 * r1;

	float R,G,B;
	switch (pni.state) {
		case PNSTATE_FLUSH:		R = G = 0.9; B = 0;		break;
		default:				R = 0.5; G = B = 0;		break;
	}

	glLineWidth(2);
	glColor4f(R,G,B,af);
	glBegin(GL_LINES);
		glVertex3dv(r1.get_pointer());
		glVertex3dv(r2.get_pointer());
	glEnd();
	glLineWidth(1);

	glTranslated(r2.x, r2.y, r2.z);
	float scl = 0.15*norm(r2-r1);
	glScalef(scl,scl,scl);
	

	float mat_d[] = { R,G,0,af };
	float mat_a[] = { 0,0,0,af };
	float mat_s[] = { 1,1,1,1 };
	float mat_e[] = { R,G,0,1 };
	float mat_sh[]  = { 100.0 };
	glPushAttrib(GL_LIGHTING_BIT);
	glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE,  mat_d);
	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT,  mat_a);
	glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, mat_s);
	glMaterialfv(GL_FRONT_AND_BACK, GL_SHININESS, mat_sh);
	glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, mat_e);
	float lit_s[] = { 1,1,1,1 };
	glLightfv(GL_LIGHT0, GL_SPECULAR, lit_s);

	glEnable(GL_NORMALIZE);
	glEnable(GL_LIGHTING);
	gl_draw_sphere(30);
	glDisable(GL_LIGHTING);
	glPopAttrib();
}






//--------------
//  n\|C^
//--------------
void
draw_pointer_on_sphere(float screen_w, float screen_z, wgl_font& fnt, float lon, float lat, float ltf)
{
	const float thR = tan(20.0f * D2Rf);		// |C^\鎞̋̎a
	const float thR2 = thR * thR;

	// ̔
	GLfloat MM[16];
	glGetFloatv( GL_MODELVIEW_MATRIX,  MM);

	const float L2  = MM[12]*MM[12] + MM[13]*MM[13] + MM[14]*MM[14];	// S܂ł̋
	const float R2  = MM[0] *MM[0]  + MM[1] *MM[1]  + MM[2] *MM[2];		// a
		
	//-- ̒̏ꍇ
	float L02 = L2 - R2;
	if (L02 <= 0.0f)	{ return; }

	//--- ꍇ́A\
	if (R2/L2 < thR2)	{ return; }


	glPushMatrix();
		float af = (R2/L2)/thR2 - 1.0f;
		if (af > 1.0f) af = 1.0f;

		vector3f  r0(MM[12], MM[13], MM[14]);

		const double th  = D2R * (90.0 - lat);
		const double phi = D2R * lon;
		const double rho = sin(th);
		vector3f  pos(rho*cos(phi), rho*sin(phi), cos(th));
		pos *= 1.004;

		glTranslatef(pos.x, pos.y, pos.z);

		glPushAttrib(GL_ENABLE_BIT);
		glDisable(GL_DEPTH_TEST);

		// NX}[N̕`
		prepare_3Dtext_2(r0, 0, 4.0*ltf/1.2, screen_w, screen_z, false, true);

		glColor4f(0,1,0,af);
		glLineWidth(2.0f);
		const float d = 0.3;
		glBegin(GL_LINES);
			glVertex3f(-d,0,0);
			glVertex3f( d,0,0);
			glVertex3f(0,-d,0);
			glVertex3f(0, d,0);
		glEnd();

		// oxEܓx\
		gltext  txt;
		char szText[100];
		char EW = (lon >= 0.0f)  ?  'E' : 'W';
		char NS = (lat >= 0.0f)  ?  'N' : 'S';

		
		sprintf(szText, "%3.1f%c, %3.1f%c", fabs(lon), EW, fabs(lat), NS);
		txt.set_text(szText);
		glPushMatrix();
			glTranslatef(1,0,0);
			txt.draw(fnt);
		glPopMatrix();

		glPopAttrib();

	glPopMatrix();

}



void
draw_pointer_on_TopoSphere(const TopoSphere& tp, float screen_w, float screen_z, wgl_font& fnt,   float lon, float lat, float ltf)
{
	if (!tp.is_loaded()) {
		glPushMatrix();
			float angle = 180.0;
			glRotatef(angle, 0,0,1);
			draw_pointer_on_sphere(screen_w, screen_z, fnt, lon, lat, ltf);
		glPopMatrix();
		return;
	}

	const float thR = tan(20.0f * D2Rf);		// |C^\鎞̋̎a
	const float thR2 = thR * thR;

	//
	GLfloat MM[16];
	glGetFloatv( GL_MODELVIEW_MATRIX,  MM);

	// ̔
	const float L2  = MM[12]*MM[12] + MM[13]*MM[13] + MM[14]*MM[14];	// S܂ł̋
	const float R2  = MM[0] *MM[0]  + MM[1] *MM[1]  + MM[2] *MM[2];		// a
		
	//-- ̒̏ꍇ
	float L02 = L2 - R2;
	if (L02 <= 0.0f)	return;

	//--- ꍇ
	if (R2/L2 < thR2)	return;

	glPushMatrix();
		float af = (R2/L2)/thR2 - 1.0f;
		if (af > 1.0f) af = 1.0f;

		vector3f  r0(MM[12], MM[13], MM[14]);	// ̒S̈ʒu
		vector3f  pos = tp.get_pos(lon, lat);
		float elv = float(tp.get_elevation(lon, lat));

		glTranslatef(pos.x, pos.y, pos.z);

		glPushAttrib(GL_ENABLE_BIT);
		glDisable(GL_DEPTH_TEST);

		// NX}[N̕`
		prepare_3Dtext_2(r0, 0, 4.0*ltf/1.2, screen_w, screen_z, false, true);

		glColor4f(0,1,0,af);
		glLineWidth(2.0f);
		const float d = 0.3;
		glBegin(GL_LINES);
			glVertex3f(-d,0,0);
			glVertex3f( d,0,0);
			glVertex3f(0,-d,0);
			glVertex3f(0, d,0);
		glEnd();

		// oxEܓx\
		gltext  txt;
		char szText[100];
		char EW = (lon >= 0.0f)  ?  'E' : 'W';
		char NS = (lat >= 0.0f)  ?  'N' : 'S';
		
		sprintf(szText, "%3.1f%c, %3.1f%c", fabs(lon), EW, fabs(lat), NS);
		txt.set_text(szText);
		glPushMatrix();
			glTranslatef(1,0,0);
			txt.draw(fnt);
		glPopMatrix();

		sprintf(szText, "%4.1fm", elv);
		txt.set_text(szText);
		glPushMatrix();
			glTranslatef(1,-1,0);
			txt.draw(fnt);
		glPopMatrix();
		glPopAttrib();
	glPopMatrix();
}




