/**************************************************************************************************

Copyright (c) 2007   Tsunehiko Kato  and  4D2U Project, National Astronomical Observatory of Japan

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEFAvj̕擾
邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ܂Bɂ́A\tgEFA̕
gpAʁAύXAAfځAЕzATuCZXA/܂͔̔錠Aу\tgEFA
񋟂鑊ɓƂ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕɋLڂ̂Ƃ
B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂Ȃ񋟂܂B
łۏ؂Ƃ́AiA̖ړIւ̓KAьNQɂĂ̕ۏ؂܂݂܂AɌ
̂ł͂܂B ҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\t
gEFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
***************************************************************************************************/
#include  "mtk_planet_eclipse.h"

#include  "mitaka.h"
#include  "../common/astro/astro_const.h"
#include  "mtk_planet_position.h"
#include  "mtk_planet_orientation.h"
#include  "mtk_planet_phys_params.h"
#include  "mtk_eclipse.h"
#include  "mtk_planetarium.h"
#include  "mtk_switches.h"



//***** 
const float R_sun_km  = 696000;




//-------------
//  H̉e
//-------------
void
draw_planet_eclipse(const mtk_draw_struct& ds, int plnt_idx, int sat_idx)
{
	double R1, R2, Rs;
	vector3d r1, r2, rs;

	double Rx, Ry, Rz;
	get_satellite_size(sat_idx, Rx, Ry, Rz);


	r1 = get_planet_position(plnt_idx);
	R1 = get_planet_Re(plnt_idx) * _1km_pc;
	r2 = get_satellite_position(sat_idx);
	R2 = Rx * _1km_pc;
	rs = vector3d(0,0,0);
	Rs = R_sun_km * _1km_pc;

	matrix3d M = get_planet_ec_to_pl_matrix(plnt_idx);

	vector3d ex, ey, ez;
	get_planet_bases(plnt_idx, ex, ey, ez);

	float th_c = ds.rad_per_pixel;
	if (tyMode == MODE_PLANETARIUM) {
		th_c /= get_planetarium_zooming_factor();
	}

	draw_eclipse_shadow(ds,
						r1, R1, ez, get_planet_f(plnt_idx),
						r2, R2, rs, Rs, M, th_c, 30, 30,
						(swEclipse & ECLIPSE_DISP), (swEclipse & ECLIPSE_BORDER));
}



//---------------
//  qH̉e
//---------------
void
draw_satellite_eclipse(const mtk_draw_struct& ds, int sat_idx, int plnt_idx)
{
	double R1, R2, Rs;
	vector3d r1, r2, rs;

	double Rx, Ry, Rz;
	get_satellite_size(sat_idx, Rx, Ry, Rz);

	r1 = get_satellite_position(sat_idx);
	R1 = Rx * _1km_pc;
	r2 = get_planet_position(plnt_idx);
	R2 = get_planet_Re(plnt_idx)*_1km_pc;
	rs = vector3d(0,0,0);
	Rs = R_sun_km * _1km_pc;
				
	matrix3d M = get_satellite_ec_to_sat_matrix(sat_idx);

	vector3d ex, ey, ez;
	get_satellite_bases(sat_idx, ex, ey, ez);

	float th_c = ds.rad_per_pixel;
	if (tyMode == MODE_PLANETARIUM) {
		th_c /= get_planetarium_zooming_factor();
	}

	draw_eclipse_shadow(ds,
						r1, R1, ez, 0.0,
						r2, R2, rs, Rs, M, th_c, 30, 30,
						(swEclipse & ECLIPSE_DISP), (swEclipse & ECLIPSE_BORDER)
						);
}
