/**************************************************************************************************

Copyright (c) 2007   Tsunehiko Kato  and  4D2U Project, National Astronomical Observatory of Japan

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEFAvj̕擾
邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ܂Bɂ́A\tgEFA̕
gpAʁAύXAAfځAЕzATuCZXA/܂͔̔錠Aу\tgEFA
񋟂鑊ɓƂ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕɋLڂ̂Ƃ
B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂Ȃ񋟂܂B
łۏ؂Ƃ́AiA̖ړIւ̓KAьNQɂĂ̕ۏ؂܂݂܂AɌ
̂ł͂܂B ҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\t
gEFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
***************************************************************************************************/
#include  "mitaka.h"
#include  "mtk_planets.h"
#include  "mtk_object.h"
#include  "mtk_object_position.h"
#include  "mtk_planet_position.h"
#include  "mtk_planet_orientation.h"
#include  "mtk_planet_phys_params.h"
#include  "mtk_lunar_pos.h"
#include  "mtk_planetarium.h"
#include  "mtk_planet_eclipse.h"
#include  "mtk_label.h"
#include  "mtk_calc_alpha.h"
#include  "mtk_minor_planets.h"
#include  "mtk_oort_cloud.h"
#include  "mtk_time.h"
#include  "mtk_stars.h"
#include  "mtk_place_name_earth_mars.h"
#include  "mtk_switches.h"
#include  "mtk_atmosphere.h"
#include  "mtk_font.h"
#include  "mtk_text.h"
#include  "mtk_gl_common.h"
#include  "mtk_planetary_ring.h"
#include  "mtk_dialog_box.h"
#include  "mtk_OpenGL.h"
#include  "../common/astro/astro_const.h"
#include  "../common/graphics/gl_triangle_mesh.h"
#include  "mtk_triangle_mesh.h"
#include  "mtk_colors.h"
#include  "mtk_eclipse.h"


//-----------
//  Externs
//-----------
extern int win_w, win_h;
extern int  gl_w, gl_h;
extern bool bDrawLowRes;

//--------
//  Size
//--------
const char* szObjectNameSizeDef			= "2.8";
const char* szSpecialObjectNameSizeDef	= "3.8";
const char* szSatelliteNameSizeDef		= "2.5";
const char* szDwarfPlanetNameSizeDef	= "2.6";
const char* szSmallObjectNameSizeDef	= "2.4";
float  ObjectNameSize, SpecialObjectNameSize, SatelliteNameSize;
float  DwarfPlanetNameSize, SmallObjectNameSize;

//------------
//  Lighting
//------------
float LightingAmbient;
float LightingAmbientDef = 0.1;
float AtmosphereIntensity;
float AtmosphereIntensityDef = 6.0;
float EarthSpecular;
float EarthSpecularDef = 6.0;
float EarthShininess;
float EarthShininessDef = 60;
float SunGlareSize;
float SunGlareSizeDef = 5;
const char* szSunGlareColorDef = "#FFF2EE";
RGBf colSunGlare;

//----------
//  Others
//----------
int EarthCityLightsIniDef = 0;
bool EarthCityLightsIni   = false;
const char* szOrbitWidthDef  = "1.2";
float OrbitWidth;
float	calc_alpha2(const mtk_draw_struct& ds, const double& r, const float rs1, const float rs2);
void	set_side_light(const mtk_draw_struct& ds);

//-------------
//  Constants
//-------------
const int PLANET_NUM = 9;
const char szPlanetTexFileName[PLANET_NUM][20] = {
	"mercury.jpg", "venus.jpg", "earth.jpg", "mars.jpg",
	"jupiter.jpg", "saturn.jpg", "uranus.jpg", "neptune.jpg", "pluto.jpg"
};

struct satellite_texture_info {
	int satellite_no;
	const char* tex_file_name;
};

const satellite_texture_info  sat_tex[] = {
	{ SAT_MOON,		"moon.jpg"		},
	{ SAT_PHOBOS,	"phobos.jpg"	},
	{ SAT_DEIMOS,	"deimos.jpg"	},
	{ SAT_IO,		"io.jpg"		},
	{ SAT_EUROPA,	"europa.jpg"	},
	{ SAT_GANYMEDE,	"ganymede.jpg"	},
	{ SAT_CALLISTO,	"callisto.jpg"	},
	{ SAT_MIMAS,	"mimas.jpg"		},
	{ SAT_TITAN,	"titan.jpg"		},
	{ SAT_CHARON,	"charon.jpg"	}
};
const int sat_tex_num = sizeof(sat_tex)/sizeof(sat_tex[0]);

char  satellite_tex_idx[50];


const int EARTH_DETAIL_TEXTURE_NUM = 3;
const char szEarthDetailTexFileName[EARTH_DETAIL_TEXTURE_NUM][30] = {
	"earth_japan.png",		// {
	"earth_hawaii.png",		// nC
	"earth_chile.png"		// `AALMA
};

const zoom_rate ZoomRate[4] = {
	{   1,  1,  1,   1,  1},
	{ 500,  1, 25,  20,  1},
	{1000, 25, 50, 100,  5},
	{1500, 50, 70, 200, 10}
};

const float TopoZoomRate[5] = {
	1.0f, 2.0f, 5.0f, 10.0f, 20.0f
};

//  z
const float  B_V_sun = 0.65;
const float  Tc_sun = B_V_to_Tc(B_V_sun);
const RGBf  col_sun( correct_RGB( blackbody_color(Tc_sun) ) );



//-----------
//  Objects
//-----------

//--  TopoSphere  --
TopoSphere	tpEarth, tpMars;	// n`
PlaceName   pnEarth, pnMars;	// n

//--  Planetary rings  --
particle_ring  prSaturn(1.236, 2.329), prUranus(1.487, 2.001);

//--  Textures  --
GLuint	texPlanets[PLANET_NUM];
GLuint	texSatellites[10];
GLuint	texEarthCloud, texEarthLights, texEarthSpecular;
GLuint	texEarthDetail[6];	//****
GLuint	texSun;
GLuint	texSaturnRing, texUranusRing;

char ZoomMode = 0;
char TopoZoomMode = 0;

//--------------------
//  Register objects
//--------------------
void
register_object_sun()
{
	mtk_object  obj;

	//  register object
	obj.init(OBJ_TYPE_SUN, 0, 0.0f);
	register_object(obj);
	
	// register label
	const bilingual bszSun			= { "Sun",			"{z|悤}" };
	bilingual  name = bszSun;
	float R   = 1.4 * _1km_pc * R_sun_km;
	float thc = 5 * D2R;	//**
	int label_idx = add_label( name.text_J, name.text_E, mtk_object(OBJ_TYPE_SUN, 0, 0.0f), MTK_COLOR_NAME_SPECIAL_OBJECT, 1.0f, SpecialObjectNameSize, R, thc );
	obj.init(OBJ_TYPE_LABEL, label_idx, 0.1f);
	register_object(obj);
}

void
register_object_planets()
{
	mtk_object  obj;
	for (int i=0; i<9; i++) {	//******//

		//--  register planets
		obj.init(OBJ_TYPE_PLANET, i, 0.0f);
		register_object(obj);

		//--  register labels
		bilingual  name = get_planet_name(i);
		float R   = 1.4 * _1km_pc * get_planet_Re(i);
		float thc = 5 * D2R;

		int color_no;
		float name_size;
		if (i==8) {
			color_no  = MTK_COLOR_NAME_DWARF_PLANET;
			name_size = DwarfPlanetNameSize;
		} else {
			color_no  = MTK_COLOR_NAME_OBJECT;
			name_size = ObjectNameSize;
		}

		int label_idx = add_label( name.text_J, name.text_E, mtk_object(OBJ_TYPE_PLANET, i, 0.0f), color_no, 1.0f, name_size, R, thc );
		obj.init(OBJ_TYPE_LABEL, label_idx, 0.0f);
		register_object(obj);
	}
}


void
register_object_satellites()
{
	mtk_object  obj;
	for (int i=0; i<get_satellites_num(); i++) {	//******//

		//--  register satellites
		obj.init(OBJ_TYPE_SATELLITE, i, 0.0f);
		register_object(obj);

		//--  register labels
		bilingual  name = get_satellite_name(i);
		double Rx, Ry, Rz;
		get_satellite_size(i, Rx,Ry,Rz);
		float R = 1.4 * _1km_pc * Rx;
		float thc = 8 * D2R;
		int label_idx = add_label( name.text_J, name.text_E, mtk_object(OBJ_TYPE_SATELLITE, i, 0.0f), MTK_COLOR_NAME_SATELLITE, 1.0f, SatelliteNameSize, R, thc );
		obj.init(OBJ_TYPE_LABEL, label_idx, 0.0f);
		register_object(obj);
	}
}


void
register_solar_system_objects()
{
	register_object_sun();
	register_object_planets();
	register_object_satellites();
	register_small_objects();
	register_object_Oort_cloud();
}



//
//
//
zoom_rate
get_zoom_rate()
{
	return ZoomRate[ZoomMode];
}

void
set_zoom_mode(char mode)
{
	ZoomMode = mode;
	const double  t = get_time_JD();
	update_objects_position_and_orientation(t, true);
	update_space_curves(t);
}

char
get_zoom_mode()
{
	return ZoomMode;
}

void
set_topo_zoom_mode(char mode)
{
	TopoZoomMode = mode;
	const float elv_fac = TopoZoomRate[TopoZoomMode];
	tpEarth.set_elv_fac(elv_fac);
	tpMars.set_elv_fac(elv_fac);
}

char
get_topo_zoom_mode()
{
	return TopoZoomMode;
}



//-----------------
//  Load Textures
//-----------------
void
set_earth_texture0(TopoSphere& tp, GLuint texname, int px1, int py1, int lv, int pw, int ph, int x1, int y1, int tex_w, int tex_h)
{
	const int img_w = 8192;
	const int img_h = 4096;

	float x1p, y1p;
	x1p = float(px1) / 180.0 * img_w;
	y1p = float(py1) /  90.0 * img_h;
	const float u1 = (x1p-x1)/tex_w;
	const float v1 = 1.0 - (y1p-y1)/tex_h;
	const float du =  float(img_w/180.0)/tex_w;
	const float dv = -float(img_h/90.0) /tex_h;

	float v = v1;
	for (int iy=0; iy<ph; iy++) {
		float u = u1;
		for (int ix=0; ix<pw; ix++) {
			patch_texture_info  pti;
			pti.texname = texname;
			pti.u1 = u;
			pti.v1 = v;
			pti.u2 = u + du;
			pti.v2 = v + dv;
			tp.set_patch_texture_info(px1+ix, py1+iy, lv, pti);
			u += du;
		}
		v += dv;
	}

}

void
set_earth_texture()
{
	TopoSphere& tp = tpEarth;
	if (!tp.is_loaded())  return;
	
	tp.set_default_texname( texPlanets[2] );
	set_earth_texture0(tp, texEarthDetail[0],  148, 17, 4, 22,22, 6735,  773, 1024,1024);		// {
	set_earth_texture0(tp, texEarthDetail[1],   9, 33, 4, 10,5,   409, 1501,  256, 128);		// nC
	set_earth_texture0(tp, texEarthDetail[2],   53, 51, 4, 5,10,  2412, 2321,  256, 512);		// `AALMA
}

void
load_solar_system_textures()
{
	//-- Sun
	SetSplashText("zƘf̃eNX`Ǎ...", "Loading textures of Sun and planets...");

	texSun = LoadTexture("sun.jpg", TexShrinkRate);
	//-- Planets
	for (int i=0; i<PLANET_NUM; ++i) {
		texPlanets[i] = LoadTexture( szPlanetTexFileName[i], TexShrinkRate );
	}

	//-- Planetary Ring
	SetSplashText("fÕeNX`Ǎ...", "Loading textures of planetary rings...");
	texSaturnRing = LoadTexture("saturn_rings.png", TexShrinkRate);
	texUranusRing = LoadTexture("uranus_rings.png", TexShrinkRate);

	//-- Earth Detail
	SetSplashText("n̏ڍ׃eNX`Ǎ...", "Loading detailed textures of Earth...");
	for (int i=0; i<EARTH_DETAIL_TEXTURE_NUM; i++) {
		texEarthDetail[i] = LoadTexture(szEarthDetailTexFileName[i], TexShrinkRate);
	}
	set_earth_texture();


	//-- Earth cloud
	SetSplashText("n̉_̃eNX`Ǎ...", "Loading texture of Earth's cloud...");
	texEarthCloud = LoadTexture("earth_cloud.jpg", TexShrinkRate);

	//-- Earth lights
	SetSplashText("n̖ĩeNX`Ǎ...", "Loading texture of Earth's lights...");
	texEarthLights = LoadTexture("earth_lights.jpg", TexShrinkRate);

	//-- Earth specular
	SetSplashText("ñXyL[}bvǍ...", "Loading texture of Earth's specular map...");
	texEarthSpecular = LoadTexture("earth_specular.jpg", TexShrinkRate);

	//-- Satellite
	SetSplashText("q̃eNX`Ǎ...", "Loading textures of satellites...");
	for (int i=0; i<sat_tex_num; ++i) {
		texSatellites[i] = LoadTexture( sat_tex[i].tex_file_name, TexShrinkRate );
	}
	for (int i=0; i<get_satellites_num(); i++) {
		satellite_tex_idx[i] = -1;
	}
	for (int i=0; i<sat_tex_num; i++) {
		satellite_tex_idx[sat_tex[i].satellite_no] = i;
	}
}


//------------------
//  Load Topograph
//------------------
void
load_earth_topograph(directory& dir, const char* filename)
{
	tpEarth.load( dir.get_path(filename) );
	tpEarth.set_elv_fac(TopoZoomRate[TopoZoomMode]);
	init_Earth_place_name(pnEarth);
}

void
load_mars_topograph(directory& dir, const char* filename)
{
	tpMars.load( dir.get_path(filename) );
	tpMars.set_elv_fac(TopoZoomRate[TopoZoomMode]);
	tpMars.shift_texture_coord(180.0f);
	init_Mars_place_name(pnMars);
}

// WnV̍Wnֈڂ
void
set_object_orientation(const matrix3d& MT)
{
	float M[16];

	M[0] = MT.m11;
	M[1] = MT.m21;
	M[2] = MT.m31;
	M[3] = 0.0;

	M[4] = MT.m12;
	M[5] = MT.m22;
	M[6] = MT.m32;
	M[7] = 0.0;

	M[8] = MT.m13;
	M[9] = MT.m23;
	M[10]= MT.m33;
	M[11] = 0.0;

	M[12] = 0.0;
	M[13] = 0.0;
	M[14] = 0.0;
	M[15] = 1.0;

	glMultMatrixf(M);
}


// ]̌ɍ킹
void
set_planet_orientation(int idx)
{
	set_object_orientation( get_planet_pl_to_ec_matrix(idx) );
}

void
set_satellite_orientation(int idx, const double& W_shift)
{
	set_object_orientation( get_satellite_sat_to_ec_matrix(idx) );

	//***********
	glRotated(W_shift,0,0,1);
}


void
set_light_from_sun(const vector3d& pos)
{
	vector3d n = normalize( pos );
	float lpos[4];
	lpos[0] = -n.x;
	lpos[1] = -n.y;
	lpos[2] = -n.z;
	lpos[3] = 0.0f;
	glLightfv( GL_LIGHT0, GL_POSITION, lpos );
}


void
set_planet_light(int idx)
{
	set_light_from_sun( get_planet_position(idx) );
}


//-----------------
// ̓V̂`
//-----------------
void
draw_celestial_object(float Rx, float Ry, float Rz)
{
	glEnable(GL_DEPTH_TEST);
	glEnable(GL_NORMALIZE);
	glEnable(GL_LIGHTING);
	glEnable(GL_TEXTURE_2D);
	glEnable(GL_BLEND);
	glPushMatrix();
		glScalef(Rx, Ry, Rz);
		glEnable(GL_CULL_FACE);
		gl_draw_LOD_sphere();
	glPopMatrix();
}


void
draw_cloud_sphere(float Rx, float Ry, float Rz)
{
	glEnable(GL_DEPTH_TEST);
	glEnable(GL_NORMALIZE);
	glEnable(GL_LIGHTING);
	glEnable(GL_TEXTURE_2D);
	glEnable(GL_BLEND);
	glDisable(GL_CULL_FACE);
	glPushMatrix();
		glScalef(Rx, Ry, Rz);
		gl_draw_LOD_sphere(true);
	glPopMatrix();
	glEnable(GL_CULL_FACE);
}


//-------------------
//  f̎]`
//-------------------
void
draw_planet_axis(const float Rz)
{
	glDisable(GL_LIGHTING);
	glDisable(GL_TEXTURE_2D);
	glLineWidth(1.5);
	glColor3f(0.8, 0.6, 0.2);
	glBegin(GL_LINES);
		glVertex3f(0,0, Rz*1.3);
		glVertex3f(0,0,-Rz*1.3);
	glEnd();
}


//-------
//  n
//-------
vector2d	get_landing_pos();

void
draw_Earth(const mtk_draw_struct& ds, bool bPointer, bool bWire)
{
	const frustum frs = ds.frs;
	const char lang = ds.lang;
	const vector3d  r0 = get_planet_position(PLNT_EARTH);


	glLineWidth(1.0f);
	glColor3f(0,1,0);

	if (tpEarth.is_loaded()) {
		tpEarth.draw(frs, bWire, bDrawLowRes);
	} else {
		glPushMatrix();
			glEnable(GL_LIGHTING);
			glEnable(GL_NORMALIZE);

			glBindTexture(GL_TEXTURE_2D, texPlanets[2]);
			gl_draw_LOD_sphere();
		glPopMatrix();
	}

	const float spc = EarthSpecular;
	float mat0[] = {0,0,0, 1};
	float mat_s[] = {spc, spc, spc, 1};
	glPushAttrib(GL_LIGHTING_BIT | GL_ENABLE_BIT);
		glEnable(GL_TEXTURE_2D);
		glEnable(GL_LIGHTING);
		glEnable(GL_NORMALIZE);
		glDisable(GL_DEPTH_TEST);
		glEnable(GL_BLEND);
		glBlendFunc(GL_ONE, GL_ONE);
		glMaterialfv( GL_FRONT_AND_BACK , GL_AMBIENT,    mat0 );
		
		// i
		float difi = 1.0;
		if ( !test_disp_switch(DISPSW_PLANET, DISPM_CITY_LIGHTS) ) {
			const float difi0 = 0.3;
			const double R  = norm(ds.camera.get_pos() - r0) * _1pc_meter;
			const double Re = get_planet_Re(2) * 1000;
			const double h = R - Re;
			difi = difi0 * (1 - h/(1.7*Re));
			if (difi > 1.0) difi = 1.0;
			if (difi < 0.0) difi = 0.0;
		} else {
			float cosphi = dot_product( normalize(r0), normalize(ds.camera.get_pos() - r0) );
			if (cosphi <= 0.0)  difi = 0;
			else				difi *= cosphi;
		}

		if (difi > 0.0) {
			float mat_d[4];
			for (int i=0; i<3; i++) {
				mat_d[i] = difi;
			}
			mat_d[3] = 1.0;

			glMaterialfv( GL_FRONT_AND_BACK , GL_DIFFUSE,    mat_d );
			glBindTexture(GL_TEXTURE_2D, texEarthLights);
			gl_draw_LOD_sphere(false, true);
		}
		
		// Cʂ̋ʔ
		RGBf hl_col;
		{
			const float zrt = get_zoom_rate().zmhPlanet;
			const float H  = 8000 * zrt;		// XP[nCg(H=8km)
			const float n0 = 2.69e25 / zrt;		// number density
			RGBf F = calc_intensity_of_highlight(ds.camera.get_pos(), r0, vector3d(0,0,0), get_planet_Re(2)*1000, 10, H, n0, 1, 30);
			F = spc * F;

			float Fmax = max(F.r, max(F.g, F.b));
			if (Fmax > 1.0) {
				F = correct_RGB(F/Fmax) * Fmax;
			} else {
				F = correct_RGB(F);
			}

			hl_col = F;
		}
		glPushMatrix();
			glBindTexture(GL_TEXTURE_2D, texEarthSpecular);
			draw_planet_highlight(ds, 2, hl_col);
		glPopMatrix();

		glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glPopAttrib();

	// C̕`
	if (AtmosphereMode != ATMOSPHERE_NONE) {
		const float I0 = AtmosphereIntensity;  //4.0;
		const float zrt = get_zoom_rate().zmhPlanet;
		const float H  = 8000 * zrt;		// XP[nCg(H=8km)G
		const float n0 = 2.69e25 / zrt;		// number density
		draw_atmosphere(get_planet_Re(2) * 1000.0, H, 6.0, n0, I0, (AtmosphereMode == ATMOSPHERE_MULTIPLE));
	}

	// _̕\
	if ( test_disp_switch( DISPSW_PLANET, DISPM_CLOUD ) ) {
		glBindTexture(GL_TEXTURE_2D, texEarthCloud);
		glEnable(GL_BLEND);
		glBlendFunc(GL_ONE, GL_ONE);
		glDepthMask(GL_FALSE);
		const double h = 10.0/6378.1;	// _̔a̘faƂ̔
		float Rc = 1.0 + h * TopoZoomRate[TopoZoomMode];

		draw_celestial_object(Rc, Rc, Rc);

		glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
		glDepthMask(GL_TRUE);
	}

	// H̉e
	if (swEclipse & (ECLIPSE_DISP | ECLIPSE_BORDER)) {
		draw_planet_eclipse(ds, PLNT_EARTH, SAT_MOON);
	}

	// n
	if ( test_disp_switch(DISPSW_PLANET, DISPM_NAME)  &&  tySubMode != SUBMODE_3DCHART) {
		pnEarth.draw_on_TopoSphere(tpEarth, screen_w, screen_z, get_font(), (lang==LANG_ENG), ds.ltf);
	}

	// |C^
	if (bPointer) {
		glDisable(GL_LIGHTING);
		glDisable(GL_TEXTURE_2D);
		glEnable(GL_BLEND);
		vector2d lon_lat = get_landing_pos();
		draw_pointer_on_TopoSphere(tpEarth, screen_w, screen_z, get_font(), lon_lat.x, lon_lat.y, ds.ltf);
	}

	glEnable( GL_DEPTH_TEST );
	glDisable(GL_NORMALIZE);
}

void
draw_Jupiter_shadow(const mtk_draw_struct& ds, const double& jd)
{
	if (!(swEclipse & (ECLIPSE_DISP | ECLIPSE_BORDER)))  return;

	int sat_num = 4;
	const int sat_idx[] = { SAT_IO, SAT_EUROPA, SAT_GANYMEDE, SAT_CALLISTO };
	for (int i=0; i<sat_num; i++) {
		int idx = sat_idx[i];
		draw_planet_eclipse(ds, PLNT_JUPITER, idx);
	}
}


//------------------------------
//  f
//   ʒuƎ]킹ĂĂ
//------------------------------
void
draw_planet(const mtk_draw_struct& ds, int idx, bool bAxis, bool bFar)
{
	const mtk_target& tgt = ds.tgt;
	bool bTarget = (tgt.cls == TGTCLS_PLANET && tgt.id2 == idx);
	const char lang = ds.lang;

	glBindTexture(GL_TEXTURE_2D, texPlanets[idx]);
	glRotatef(180,0,0,1);

	const float Rz = 1.0/(1.0f+get_planet_f(idx));

	glDisable(GL_BLEND);

	//---  ]̕`  ---
	if (bAxis) draw_planet_axis(Rz);

	//---  f{̂̕`  ---
	const frustum frs = ds.frs;
	bool bWire = false;	//
	glEnable(GL_TEXTURE_2D);

	if (tyMode==MODE_HIPPARCOS && (idx==2 || idx==3)) {

		//--- n ---
		if (idx==2) {
			draw_Earth(ds, bSurfacePointer && bTarget && tySubMode != SUBMODE_3DCHART, false);
		}

		//--- ΐ ---
		if (idx==3) {
			glLineWidth(1.0f);
			glColor3f(0,1,0);
			tpMars.draw(frs, bWire, bDrawLowRes);

			if ( test_disp_switch( DISPSW_PLANET, DISPM_NAME )  &&  tySubMode != SUBMODE_3DCHART) {
				pnMars.draw_on_TopoSphere(tpMars, screen_w, screen_z, get_font(), (lang==LANG_ENG), ds.ltf);
			}

			if (bSurfacePointer && bTarget && tySubMode != SUBMODE_3DCHART) {
				glDisable(GL_LIGHTING);
				glDisable(GL_TEXTURE_2D);
				glEnable(GL_BLEND);
				vector2d lon_lat = get_landing_pos();
				draw_pointer_on_TopoSphere(tpMars, screen_w, screen_z, get_font(), lon_lat.x, lon_lat.y, ds.ltf);
			}

			// C
			if (AtmosphereMode != ATMOSPHERE_NONE) {
				const float I0 = AtmosphereIntensity; //0.3;
				const float  H = 11000;			// XP[nCg(H=11km)
				const float n0 = 4e23;		// number density
				const double h = norm( ds.camera.get_pos() - ds.target_pos )*_1pc_km*1000;
				draw_atmosphere(get_planet_Re(3) * 1000.0, H, 8.0, n0, I0, false);
			}
			glDisable(GL_NORMALIZE);
		}
	} else {
		draw_celestial_object(1, 1, Rz);

		if (idx == 4) {
			draw_Jupiter_shadow(ds, ds.JD);
		}

		if (bSurfacePointer && bTarget && tySubMode != SUBMODE_3DCHART) {
			glDisable(GL_TEXTURE_2D);
			glDisable(GL_LIGHTING);
			glEnable(GL_BLEND);
			glLineWidth(1.0f);
			glColor3f(0,1,0);
			glRotatef(180,0,0,1);
			vector2d lon_lat = get_landing_pos();
			draw_pointer_on_sphere(screen_w, screen_z, get_font(), lon_lat.x, lon_lat.y, ds.ltf);
		}
	}

	if (hasPlanetRing(idx)) {
		glPushMatrix();
			glScalef(1, 1, 1.0/(1.0f+get_planet_f(idx)));
	
			if (idx==5)	{	// y̗
				glBindTexture(GL_TEXTURE_2D, texSaturnRing);
				prSaturn.draw();
			}
			if (idx==6)	{	// V̗
				glBindTexture(GL_TEXTURE_2D, texUranusRing);
				prUranus.draw();
			}
		glPopMatrix();
	}

	glDisable(GL_NORMALIZE);
}



//---------------
//  3D `[gp
//---------------
void
draw_planet2(int idx)
{
	glBindTexture(GL_TEXTURE_2D, texPlanets[idx]);
	glRotatef(180,0,0,1);
	const float Rz = 1.0/(1.0f+get_planet_f(idx));
	glDisable(GL_BLEND);

	//---  f{̂̕`  ---
	glEnable(GL_TEXTURE_2D);
	draw_celestial_object(1, 1, Rz);

	// n̉_\
	if ( test_disp_switch(DISPSW_PLANET, DISPM_CLOUD) && idx==2) {
		glBindTexture(GL_TEXTURE_2D, texEarthCloud);
		glEnable(GL_BLEND);
		glBlendFunc(GL_SRC_COLOR, GL_ONE_MINUS_SRC_COLOR);
		float Rc = 1.0 + 8 * TopoZoomRate[TopoZoomMode] / get_planet_Re(2);
		draw_celestial_object(Rc, Rc, Rc);
		glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	}

	if (hasPlanetRing(idx)) {
		glPushMatrix();
			glScalef(1, 1, 1.0/(1.0f+get_planet_f(idx)));
	
			if (idx==5)	{	// y̗
				glBindTexture(GL_TEXTURE_2D, texSaturnRing);
				prSaturn.draw();
			}
			if (idx==6)	{	// V̗
				glBindTexture(GL_TEXTURE_2D, texUranusRing);
				prUranus.draw();
			}
		glPopMatrix();
	}

	glDisable(GL_NORMALIZE);
}

//------------
//  q̕`
//------------
void
draw_satellite(const mtk_draw_struct& ds, int idx, const vector3d& rpos, double scl)
{
	const float rpp = ds.rad_per_pixel;	// XN[PsNZ̊pxiWAPʁj
	vector3d r_sat = get_satellite_position(idx);		// q̈ʒuiSW, in pcj

	double Rx, Ry, Rz;
	get_satellite_size(idx, Rx, Ry, Rz);
	Rx *= scl * _1km_pc;
	Ry *= scl * _1km_pc;
	Rz *= scl * _1km_pc;
	double th_view  = 2 * Rx / rpos.norm();		// a
	double th = 0.3 * th_view;

	float lv = 1.0f;
	if (th < rpp) {
		lv = th*th/(rpp*rpp);
		lv *= 500;	// amplification
		if (lv < 0.01f)  return;
		if (lv > 1.0f)   lv = 1.0f;
	}
	
	const float ptsz = 2.0;
	glColor3f(lv,lv,lv);
	glPushMatrix();
		glTranslatef(rpos.x, rpos.y, rpos.z);

		if (th < rpp) {
			glDisable(GL_TEXTURE_2D);
			glDisable(GL_LIGHTING);
			glEnable(GL_BLEND);
			glPointSize(ptsz);
			glBegin(GL_POINTS);
				glVertex3f(0,0,0);
			glEnd();
		} else {
			if (!bSideLight)	set_light_from_sun(r_sat);
			else				set_side_light(ds);

			set_satellite_orientation(idx, 180.0);		// ]щ]pZbg

			char tex_no = satellite_tex_idx[idx];
			if (tex_no != -1) {
                glBindTexture(GL_TEXTURE_2D, texSatellites[tex_no]);
			}

			if ( test_disp_switch(DISPSW_PLANET, DISPM_AXIS) ) draw_planet_axis(Rz);
			draw_celestial_object(Rx, Ry, Rz);

			if (swEclipse & (ECLIPSE_DISP | ECLIPSE_BORDER)) {
				if (idx == SAT_MOON) {
					glPushMatrix();
						glScalef(Rx,Ry,Rz);
						draw_satellite_eclipse(ds, SAT_MOON, PLNT_EARTH);
					glPopMatrix();
				}
			}
		}
	glPopMatrix();
	glPointSize(1);
}



void
draw_a_satellite(const mtk_draw_struct& ds, int idx, const vector3d& rpos, double scl)
{
	glEnable(GL_LIGHT0);
	float mat_d[] = {1,1,1,1}, mat_a[] = {0.5,0.5,0.5,1};
	mat_a[0] = mat_a[1] = mat_a[2] = LightingAmbient;
	glMaterialfv( GL_FRONT_AND_BACK , GL_DIFFUSE,   mat_d );
	glMaterialfv( GL_FRONT_AND_BACK , GL_AMBIENT,   mat_a );

	draw_satellite(ds, idx, rpos, scl);

	glDisable(GL_LIGHTING);
	glDisable(GL_TEXTURE_2D);
	glEnable(GL_BLEND);
}



//-------
//  Sun
//-------
float
get_sun_label_alpha(const mtk_draw_struct& ds)
{
	const float scale = ds.scale;
	float af;

	float scl_max = 5e5;
	if (scale >= scl_max)  return 0;

	if (scale >= 3e4)  {
		af = 1 - scale/scl_max;
		if (af <= 0) return 0;
	} else {
		af = 1.0;
	}

	return  af;
}


//-----------
//  fO
//-----------
void
register_planets_orbit_curves()
{
	for (int i=0; i<9; i++) {	//***
		int color_no = (i==8) ? MTK_COLOR_ORBIT_DWARF_PLANET : MTK_COLOR_ORBIT_PLANET;
		space_curve  sc( mtk_object(OBJ_TYPE_PLANET, i, 0.0f), OrbitWidth, color_no );
		register_space_curve( sc );
	}
}


void
make_planets_orbit_curve(space_curve& sc, int div_N)
{
	const int idx = sc.get_related_object().get_index();

	sc.clear();
	for (int i=0; i<div_N; i++) {
		double phi = 2.0 * M_PI * double(i) / div_N;
		sc.add_point( calc_planet_orbit_pos(idx, phi) );
	}
}


float
get_planet_label_alpha(const mtk_draw_struct& ds, int idx)
{
	float scl = 1.0f;
	const vector3d  rpos = get_planet_position( idx ) - ds.camera.get_pos();
	float  Rv = scl * calc_visible_radius_planet( idx );
	return  calc_alpha_by_apparent_diameter(rpos, Rv, 10*D2R);
}

float
get_planet_orbit_alpha(const mtk_draw_struct& ds, int idx)
{
	const float dscl = 0.035 * _1AU_pc;
	float  alp = calc_alpha_by_disapear_scale_inside( ds.scale, dscl );
	float scl = 1.0f;
	const vector3d  rpos = get_planet_position( idx ) - ds.camera.get_pos();
	float  Rv = scl * calc_visible_radius_planet( idx );

	return  alp * calc_alpha_by_apparent_diameter(rpos, Rv, 10*D2R);
}


//-----------
//  qO
//-----------
void
register_satellites_orbit_curves()
{
	const int N = get_satellites_num();

	for (int i=0; i<N; i++) {
		space_curve  sc( mtk_object(OBJ_TYPE_SATELLITE, i, 0.0f), OrbitWidth, MTK_COLOR_ORBIT_SATELLITE );
		register_space_curve( sc );
	}
}


void
set_satellites_orbit_curve(space_curve& sc, double t)
{
	const int idx = sc.get_related_object().get_index();
	const int N = sc.get_num_points();

	for (int i=0; i<N; i++) {
		double phi = 2.0 * M_PI * double(i) / N;
		sc.set_point(i, calc_satellite_orbit_pos(idx, t, phi) );
	}
}

void
make_satellites_orbit_curve(space_curve& sc, double t, int div_N)
{
	sc.set_num_points( div_N );
	set_satellites_orbit_curve(sc, t);
}

float
get_satellite_label_alpha(const mtk_draw_struct& ds, int idx)
{
	float scl = 1.0f;
	const vector3d  rpos = get_satellite_position( idx ) - ds.camera.get_pos();
	float  Rv = scl * calc_visible_radius_satellite( idx );

	return  calc_alpha_by_apparent_diameter( rpos, Rv, 10*D2R );
}

float
get_satellite_orbit_alpha(const mtk_draw_struct& ds, int idx)
{
	int pid = get_satellite_planet_ID(idx);
	float Re = get_planet_Re(pid) * _1km_pc;
	const float dscl = 8 * Re;
	float  alp = calc_alpha_by_disapear_scale_inside( ds.scale, dscl );

	return  alp * get_satellite_label_alpha( ds, idx );
}

bool
is_satellite_selected(int idx)
{
	switch (idx) {
		case SAT_MOON:
		case SAT_PHOBOS:	case SAT_DEIMOS:
		case SAT_IO:		case SAT_EUROPA:	case SAT_GANYMEDE:	case SAT_CALLISTO:	case SAT_AMALTHEA:	case SAT_HIMALIA:
		case SAT_MIMAS:		case SAT_ENCELADUS:	case SAT_TETHYS:	case SAT_DIONE:		case SAT_RHEA:		case SAT_TITAN:
		case SAT_ARIEL:		case SAT_UMBRIEL:	case SAT_TITANIA:	case SAT_OBERON:	case SAT_MIRANDA:
		case SAT_TRITON:	case SAT_NEREID:
		case SAT_CHARON:
			return  true;
		default:	break;
	}

	return  false;
}

//------------------
//  Visible radius
//------------------
double
calc_visible_radius_planet(int idx)
{
	return  get_planet_position(idx).norm();
}

double
calc_visible_radius_satellite(int idx)
{
	return  get_satellite_position_relative_to_planet(idx).norm();
}


//-----------
//  Planets
//-----------
void
draw_a_planet_3D(const mtk_draw_struct& ds, int idx, const vector3d& rpos, double scl)
{
	glEnable(GL_LIGHT0);
	float mat_d[] = {1,1,1,1}, mat_a[] = {0.5,0.5,0.5,1};
	mat_a[0] = mat_a[1] = mat_a[2] = LightingAmbient;
	glMaterialfv( GL_FRONT_AND_BACK , GL_DIFFUSE,   mat_d );
	glMaterialfv( GL_FRONT_AND_BACK , GL_AMBIENT,   mat_a );

	const float scale			= ds.scale;
	if (scale > 500 * get_planet_a(idx) * _1AU_pc)  return;

	vector3d  pos0 = get_planet_position(idx);
	float af = calc_alpha2( ds, pos0.norm(), 0.015, 0.03 );

	// Ɩ̐ݒ
	if (!bSideLight)	{ set_planet_light(idx); }
	else				{ set_side_light(ds); }

	const float Re = scl * get_planet_Re(idx) * _1km_pc;
	glPushMatrix();
		glTranslated(rpos.x, rpos.y, rpos.z);

		glPushMatrix();
			set_planet_orientation(idx);	// ]щ]pZbg

			glEnable(GL_TEXTURE_2D);
			glEnable(GL_LIGHTING);

			glScalef(Re, Re, Re);
			draw_planet(ds, idx, test_disp_switch(DISPSW_PLANET, DISPM_AXIS), !ds.is_near_region() );
		glPopMatrix();
	glPopMatrix();

	glDisable(GL_LIGHTING);
	glDisable(GL_TEXTURE_2D);
	glEnable(GL_BLEND);
}


void
draw_planets_planetarium(const mtk_draw_struct& ds)
{
	const double R0 = 1.0023;
	const vector3d camera_pos = ds.camera.get_pos();

	glEnable(GL_TEXTURE_2D);
	glDisable(GL_BLEND);
	glColor3f(1,1,1);
	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT0);
	glEnable(GL_NORMALIZE);
	float mat_d[] = {1,1,1,1}, mat_a[] = {0.5,0.5,0.5,1};
	mat_a[0] = mat_a[1] = mat_a[2] = LightingAmbient;
	glMaterialfv( GL_FRONT_AND_BACK , GL_DIFFUSE,   mat_d );
	glMaterialfv( GL_FRONT_AND_BACK , GL_AMBIENT,   mat_a );

	const mtk_target&  tgt = ds.tgt;
	for (int i=0; i<9; ++i) {
		vector3d Rs = get_planet_position(i);
		vector3d R  = Rs - camera_pos;
		double  L = R.norm();
		
		set_planet_light(i);
		glPushMatrix();
			if (tgt.id2 != i) {
				glPushMatrix();
					vector3d rr = R0 * R/L;
					glTranslatef(rr.x,rr.y,rr.z);
					const float RR = get_planet_Re(i) * _1km_pc / L;
					glPushMatrix();
						glScalef(RR, RR, RR);
						set_planet_orientation(i);
						draw_planet(ds, i, false, false);
					glPopMatrix();

					// O
					glPushMatrix();
					if ( test_disp_switch(DISPSW_PLANET, DISPM_NAME) ) {
						float a = get_plnt_R();
						prepare_3Dtext_1(RR*1.2*a, 45, ObjectNameSize*ds.ltf, 1.0f, false);
						glDisable(GL_TEXTURE_2D);
						glDisable(GL_LIGHTING);
						glEnable(GL_BLEND);
						const RGBf& col = get_color(MTK_COLOR_NAME_OBJECT);
						glColor4f(col.r, col.g, col.b, col_star_name.a);
						draw_bilingual( get_planet_name(i) );
					}
					glPopMatrix();
				glPopMatrix();
			}
		glPopMatrix();
	}

	glDisable(GL_NORMALIZE);
	glDisable(GL_LIGHTING);
	glDisable(GL_TEXTURE_2D);
	glEnable(GL_BLEND);
}

//-------
//  z
//-------
double
get_sun_radius()
{
	return R_sun_km * _1km_pc;
}

double
get_sun_glare_radius()
{
	return  get_sun_radius() * SunGlareSize;
}



void
draw_sun0(const float& R, const RGBf& col)
{
	float mat_d[] = {1,1,1,1}, mat_a[] = {1,1,1,1};
	mat_d[0] = col.r;
	mat_d[1] = col.g;
	mat_d[2] = col.b;
	mat_a[0] = col.r;
	mat_a[1] = col.g;
	mat_a[2] = col.b;

	glMaterialfv( GL_FRONT_AND_BACK , GL_DIFFUSE,   mat_d );
	glMaterialfv( GL_FRONT_AND_BACK , GL_AMBIENT,   mat_a );
	glPushAttrib(GL_ENABLE_BIT);
	glEnable(GL_NORMALIZE);
	glEnable(GL_LIGHTING);
	glDisable(GL_LIGHT0);
	glEnable(GL_LIGHT1);
	glColor3f(1,1,1);
	glEnable(GL_TEXTURE_2D);
	glBindTexture(GL_TEXTURE_2D, texSun);
	glDisable(GL_BLEND);

	// _̈ʒuƖƂ炷
	glPushMatrix();
		toward_eye_pos();
		float pos[4];
		pos[0] = 0;
		pos[1] = 0;
		pos[2] = 1;
		pos[3] = 0.0f;
		glLightfv( GL_LIGHT1, GL_POSITION, pos );
	glPopMatrix();

	glPushMatrix();
		glScalef(R, R, R);
		gl_draw_LOD_sphere();
	glPopMatrix();
	glDisable(GL_LIGHTING);
	glDisable(GL_LIGHT1);
	glEnable(GL_LIGHT0);
	glDisable(GL_TEXTURE_2D);
	glDisable(GL_NORMALIZE);
}

void
draw_sun_glare(const float& Rd, const float alp)
{
	// OA̕\
	glDisable(GL_TEXTURE_2D);
	glDisable(GL_LIGHTING);
	glEnable(GL_DEPTH_TEST);
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE);
	glDepthMask( GL_FALSE );

	glPushMatrix();
		glScalef(Rd, Rd, Rd);
		toward_eye_pos2();
		
		glBegin(GL_TRIANGLE_FAN);
		glColor4f(colSunGlare.r, colSunGlare.g, colSunGlare.b, 0.7*alp);
		glVertex3f(0,0,0);
		for (int i=0; i<=360; i+=20) {
			float x = cos(D2R*i);
			float y = sin(D2R*i);
			glColor4f(colSunGlare.r, colSunGlare.g, colSunGlare.b, 0);
			glVertex3f(x,y,0);
		}
		glEnd();
	glPopMatrix();
	glDepthMask( GL_TRUE );
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glPopAttrib();
}

void
draw_sun(const mtk_draw_struct& ds, int idx, const vector3d& rpos, double scl)
{
	const bilingual bszSun			= { "Sun",			"{z|悤}" };
	const float scale			= ds.scale;

	if (tyMode==MODE_HIPPARCOS) {
		float af;

		float scl_max = 5e5;
		if (scale >= scl_max)  return;

		if (scale >= 3e4)  {
			af = 1 - scale/scl_max;
			if (af <= 0) return;
		} else {
			af = 1.0;
		}
		
		RGBAf rgba;
		rgba.rgb = col_sun;
		rgba.a   = af;

		// p
		const float Re = scl * R_sun_km * _1km_pc * ZoomRate[ZoomMode].zmhSun;
		double th = Re/rpos.norm();
		bool bPoint = (th < 2*0.001);

		glPushMatrix();
			glTranslated(rpos.x, rpos.y, rpos.z);

			// Draw
			if (!bPoint) {
				draw_sun0(Re, RGBf(1,1,1));
			} else {
				glEnable(GL_BLEND);
				glPointSize( 5/(ds.rad_per_pixel/0.001)  );
				glBegin(GL_POINTS);
					glColor4fv( rgba.get_pointer() );
					glVertex3f(0,0,0);
				glEnd();
			}

			// Glare
			const double D = norm(rpos);
			float aa = 400.0 / D;	// 100pc
			if (aa > 0.02) {
				if (aa > 1) aa=1;		
				float Rd = Re * SunGlareSize;
				const double thc = 1.0e-2;
				if (Rd/D < thc) {
					Rd = thc * D;
				}
				draw_sun_glare(Rd, aa);
			}
		glPopMatrix();
	} else {
		const vector3d camera_pos	= ds.camera.get_pos();
		vector3d Rs = -camera_pos;
		vector3d rr = Rs.normalized()  * 0.92;
		double  L = Rs.norm();
		float RR = R_sun_km * _1km_pc / L * get_zoom_rate().zmpSunMoon;
		const float Rc = 2*screen_w/180.0;
		
		RGBf col(1,1,1);
		
		glPushMatrix();
			glTranslated(rr.x, rr.y, rr.z);
			draw_sun0(RR, col);
			float Rd = RR * SunGlareSize;
			draw_sun_glare(Rd, 1.0f);

			if ( test_disp_switch( DISPSW_PLANET, DISPM_NAME ) ) {
				float a = get_plnt_R();
				prepare_3Dtext_1(RR*a, 45, SpecialObjectNameSize*ds.ltf, 1.0f, false);
				glDisable(GL_TEXTURE_2D);
				glDisable(GL_LIGHTING);
				glEnable(GL_BLEND);

				const RGBf &col = get_color(MTK_COLOR_NAME_SPECIAL_OBJECT);
				glColor3f(col.r, col.g, col.b);

				draw_bilingual(bszSun);
			}
		glPopMatrix();
	}
}


void
draw_moon0(const float& R)
{
	float mat_d[] = {1,1,1,1};
	float mat_a[] = {0.5,0.5,0.5,1};
	mat_a[0] = mat_a[1] = mat_a[2] = LightingAmbient;
	glMaterialfv( GL_FRONT_AND_BACK , GL_DIFFUSE,   mat_d );
	glMaterialfv( GL_FRONT_AND_BACK , GL_AMBIENT,   mat_a );

	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT0);
	glEnable(GL_NORMALIZE);
	glDisable(GL_BLEND);

	glColor3f(1,1,1);
	glEnable(GL_TEXTURE_2D);

	char tex_no = satellite_tex_idx[SAT_MOON];
	if (tex_no != -1) {
		glBindTexture(GL_TEXTURE_2D, texSatellites[tex_no]);
	}

	glScalef(R, R, R);
	gl_draw_LOD_sphere();

	glDisable(GL_NORMALIZE);
	glDisable(GL_LIGHTING);
	glDisable(GL_TEXTURE_2D);
	glEnable(GL_BLEND);
}



void
draw_moon_planetarium(const mtk_draw_struct& ds)
{
	const vector3d camera_pos	= ds.camera.get_pos();
	const double R0 = 1.002;
	vector3d rE0 = get_planet_position(PLNT_EARTH);
	vector3d R = get_satellite_position(SAT_MOON);
	set_light_from_sun( R );
	vector3d pos;
	float Rm;

	if (tyTarget==TGTNO_MOON)  return;
	R = R - camera_pos;
	double  L = R.norm();
	pos = R0 * R/L;
	Rm = R_moon_km * _1km_pc / L * get_zoom_rate().zmpSunMoon * get_zoom_rate().zmhMoonOrb;

	// p
	double th = Rm/pos.norm();
	bool bPoint = (th < ds.rad_per_pixel);
	const double thc = 0.2*ds.rad_per_pixel;
	if (th < thc)  return;

	const bilingual bszMoon = { "Moon", "{|}" };
	glPushMatrix();
		glTranslatef(pos.x,pos.y,pos.z);
	
		if (!bPoint) {

			glPushMatrix();
				set_satellite_orientation(SAT_MOON, 180);
				draw_moon0(Rm);
	
				if (swEclipse & (ECLIPSE_DISP | ECLIPSE_BORDER)) {
					glPushMatrix();
						draw_satellite_eclipse(ds, SAT_MOON, PLNT_EARTH);
					glPopMatrix();
				}
			glPopMatrix();
		} else {
			glDisable(GL_BLEND);
			glPointSize(1);
			glBegin(GL_POINTS);
				glColor3f(1,1,1);
				glVertex3f(0,0,0);
			glEnd();
		}

		// O
		if ( test_disp_switch(DISPSW_SATELLITE, DISPM_NAME) ) {
			float a = get_plnt_R();
			prepare_3Dtext_1(Rm*1.41*a, 45, SpecialObjectNameSize*ds.ltf, 1.0f, false);

			glDisable(GL_TEXTURE_2D);
			glDisable(GL_LIGHTING);
			glEnable(GL_BLEND);

			const RGBf& col = get_color(MTK_COLOR_NAME_SPECIAL_OBJECT);
			glColor3f(col.r, col.g, col.b);
			draw_bilingual(bszMoon);
		}
	glPopMatrix();
}
