/**************************************************************************************************

Copyright (c) 2007   Tsunehiko Kato  and  4D2U Project, National Astronomical Observatory of Japan

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEFAvj̕擾
邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ܂Bɂ́A\tgEFA̕
gpAʁAύXAAfځAЕzATuCZXA/܂͔̔錠Aу\tgEFA
񋟂鑊ɓƂ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕɋLڂ̂Ƃ
B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂Ȃ񋟂܂B
łۏ؂Ƃ́AiA̖ړIւ̓KAьNQɂĂ̕ۏ؂܂݂܂AɌ
̂ł͂܂B ҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\t
gEFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
***************************************************************************************************/
#include <windows.h>
#include  "mitaka.h"
#include  "mtk_gl_common.h"
#include  "mtk_stars.h"
#include  "mtk_switches.h"
#include  "mtk_font.h"
#include  "mtk_text.h"
#include  "mtk_draw_struct.h"
#include  "mtk_colors.h"
#include  "mtk_file.h"
#include  "../common/astro/constellation.h"
#include  "../common/astro/star_name.h"
#include  "../common/math/random.h"


//-----------
//  Externs
//-----------
extern float ini_obj_z;
extern float ObjectNameSize;
float	calc_alpha(const float r1, const float r2, const float r, const float fac);


//-------------
//  Constants
//-------------
const float  plx_err_thr = 0.575f;	// gpf[^̑Ό덷̍ől

//-----------
//  Objects
//-----------
static vector<mtk_star>		vStars;			// ̃e[u
static map<long, long>		HIP_table;		// HIP  vStars ̃CfbNX̎Qƃe[u
static vector<star_name>	StarNames;		// ̌ŗL̃e[u
static set<int>				HippExoplanets;	// nOf̃Xg
//-- Luminosity reference
static float  g_L_ref		= L_ref_ini;		// ~mVeB[
static float  g_log_L_ref0;
//---  ̕\p  ---
static star_picture  STP(2000, 40000, 16, 255);
static vector<star>  STARIF;
GLuint  dlStar;
GLuint  texStar;
//
float StarImagePowIndex;
float StarImagePowIndexDef = 0.38;


//------------------
//  Class mtk_star
//------------------
//--  ̖ÕeLXg  --
void
mtk_star::make_name(char _swStar, char _swCnst, char lng)
{
    name_L[0] = '\0';
	name_S[0] = '\0';

	// AŗLoCGEtX`[h΃XLbv
	if (!(_swStar & STAR_HIP) && cmn_name_idx==-1 && cnstID == -1) return;

	//-- ŗL
	name_L[0] ='\0';
	if ((_swStar & STAR_NAME) && cmn_name_idx != -1) {
		const star_name& sn = StarNames[cmn_name_idx];
		if (!(_swStar & STAR_NAME_SELECT) || sn.flg=='*') {
			strcpy(name_L, (lng==LANG_ENG)  ?  sn.name_E  :  sn.name_J);
		}
	}

	//-- oCGAtX`[hL̕\
	char str[30];
	const char* szCnst = (_swCnst & CNST_BND) ? "" : get_constellation_abbr(cnstID);

	if ((_swStar & STAR_BAYER) && BayerID!=-1) {
		const char* szBayer = get_Greek_letter_J(BayerID);
		char szBayer2[10];
		if (BayerSub != -1)		{ sprintf(szBayer2, "%s^%1d",	szBayer, BayerSub); }
		else					{ sprintf(szBayer2, "%s",		szBayer); }

		if ((_swStar & STAR_FRAMSTEED) && Framsteed!=-1)	{ sprintf(str, "%d%s%s", Framsteed, szBayer2, szCnst); }
		else												{ sprintf(str, "%s%s",	 szBayer2, szCnst); }
	} else if ((_swStar & STAR_FRAMSTEED) && Framsteed != -1) {
		sprintf(str, "%d %s", Framsteed, szCnst);
	} else {
		str[0] = '\0';
	}
	
	if (str[0] != '\0') {
		if (ADScomp!=' ')		{ sprintf(name_S, "%s%c", str, ADScomp); }
		else					{ strcpy(name_S, str); }
	} else {
		name_S[0] = '\0';
	}

	//-- HIPԍ
	if (_swStar & STAR_HIP) {
		if (name_S[0]=='\0') {
			sprintf(name_S, "%d", HIP);
		} else {
			char tmp[100];
			sprintf(tmp, "%s:%d", name_S, HIP);
			strcpy(name_S, tmp);
		}
	}
}


//-------------
//  Load Data
//-------------
int
read_a_Hipparcos_star(FILE* fp, mtk_star& st)
{
	long HIP;
	float RAdeg, DEdeg;
	float Plx, err_Plx;
	float pmRA, pmDE;
	float Vmag, B_V;
	char SpcType, SpcIdx2;
	bool bDouble;
	short Framsteed;
	char BayerID, BayerSub;
	char CnstID;
	char ADScomp;

	//--- Read one line ---
	int count;
	count = fread(&HIP,	sizeof(HIP),		1, fp);
	if (count < 1)  return FILE_END;

	fread(&RAdeg,		sizeof(RAdeg),		1, fp);
	fread(&DEdeg,		sizeof(DEdeg),		1, fp);
	fread(&Plx,			sizeof(Plx),		1, fp);
	fread(&err_Plx,		sizeof(err_Plx),	1, fp);
	fread(&pmRA,		sizeof(pmRA),		1, fp);
	fread(&pmDE,		sizeof(pmDE),		1, fp);
	fread(&Vmag,		sizeof(Vmag),		1, fp);
	fread(&B_V,			sizeof(B_V),		1, fp);
	fread(&SpcType,		sizeof(SpcType),	1, fp);
	fread(&SpcIdx2,		sizeof(SpcIdx2),	1, fp);
	fread(&bDouble,		sizeof(bDouble),	1, fp);
	fread(&Framsteed,	sizeof(Framsteed),	1, fp);
	fread(&BayerID,		sizeof(BayerID),	1, fp);
	fread(&BayerSub,	sizeof(BayerSub),	1, fp);
	fread(&CnstID,		sizeof(CnstID),		1, fp);
	fread(&ADScomp,		sizeof(ADScomp),	1, fp);
	
	//--- Error in parallax
	// 덷e͈͂傫ꍇ̓XLbviflu0.57)
	if (fabs(err_Plx) > plx_err_thr * Plx) {
		return FILE_SKIP;
	}

	//--- Distance  (in pc)
	double distance = 1.0 / (Plx * 1e-3);

	//--- Position
	const double D2R = M_PI/180.0;
	const double alp = D2R * RAdeg;
	const double dlt = D2R * DEdeg;
	const double cosd = cos(dlt);
	vector3d pos = distance * vector3d(cosd*cos(alp), cosd*sin(alp), sin(dlt));

	//--- Absolute Magnitude (in mag)
	float Mag;
	Mag = Vmag + 5.0 - 5.0 * log10(distance);

	//--- Luminosity
	const float L = pow(10.0, -0.4*Mag);

	//--- Set
	st.set_pos(pos);
	st.set_L(L);
	st.set_B_V(B_V);
	st.set_HIP(HIP);
	st.set_double(bDouble);
	st.set_name_info(CnstID, BayerID, BayerSub, Framsteed, ADScomp);
	st.set_common_name_index(-1);

	return  FILE_SUCCESS;
}

bool
load_Hipparcos_data_2(FILE* fp)
{
	mtk_star st;

	//--  Pf[^̓ǂݍ  --
	vStars.clear();
	while (true) {
		int res = read_a_Hipparcos_star(fp, st);
		if (res == FILE_FAILED)  break;
		if (res == FILE_SKIP) continue;
		vStars.push_back(st);
	}

	//--  HIP Qƃe[u̍쐬  --
	HIP_table.clear();
	for (int i=0; i<vStars.size(); i++) {
		const mtk_star& st = vStars[i];
		HIP_table.insert( pair<long,long>(st.get_HIP(), i) );
	}

	// Wnւ̕ϊ
	for (int i=0; i<vStars.size(); i++) {
		mtk_star& st = vStars[i];
		st.set_pos( M_R2E * st.get_pos() );
	}

	return  true;
}

// nOf̃Xg̓ǂݍ
bool
load_exoplanet_list(const char* filename)
{
	FILE* fp;
	if ((fp=fopen(filename, "rt")) == NULL)  return false;

	HippExoplanets.clear();
	while (true) {
		char buf[100];
		char* rs;
		rs = fgets(buf, 100, fp);
		if (rs == NULL)  break;

		int HIP;
		int count;
		count = sscanf(&buf[15], "%d", &HIP);
		if (count != 1)  continue;

		HippExoplanets.insert(HIP);
	}
	fclose(fp);

	return true;
}

//-------
//  HIP
//-------
bool
is_HIP_present(int HIP)
{
	map<long, long>::const_iterator it = HIP_table.find(HIP);
	if (it == HIP_table.end())  return false;
	return  true;
}

int
get_star_index_by_HIP(int HIP)
{
	return  HIP_table[HIP];
}

//--------
//  Size
//--------
int
get_stars_num()
{
	return  vStars.size();
}

//------------
//  Position
//------------
vector3d
get_star_position(int idx)
{
	return  vStars[idx].get_pos();
}

vector3d
get_star_position_by_HIP(int HIP)
{
	return  get_star_position( get_star_index_by_HIP(HIP) );
}


//
const mtk_star&
get_star(int idx)
{
	return  vStars[idx];
}

const mtk_star&
get_star_by_HIP(int HIP)
{
	return  get_star( get_star_index_by_HIP(HIP) );
}


//-------------------
//  ~mVeB[
//-------------------
float
get_L_ref()
{
	return g_L_ref;
}

void
set_L_ref(float L_ref)
{
	g_L_ref = L_ref;
}

float
get_log_L_ref()
{
	return g_log_L_ref0;
}


//--------------------------
//  fBXvCXg̏
//--------------------------
void
init_star_display_list()
{
	const int TempN = STP.get_TempN();
	dlStar = glGenLists(TempN);
	for (int i=0; i<TempN; ++i) {
		float du = 1.0f / TempN;
		float u1 = du*i;
		float u2 = du*(i+1);
		
		glNewList(dlStar+i, GL_COMPILE);
			glBegin(GL_QUADS);
				glTexCoord2f(u2,1);		glVertex3f(1,1,0);
				glTexCoord2f(u1,1);		glVertex3f(-1,1,0);
				glTexCoord2f(u1,0);		glVertex3f(-1,-1,0);
				glTexCoord2f(u2,0);		glVertex3f(1,-1,0);
			glEnd();
		glEndList();
	}
}


//-----------------------
//  ̃eNX`̏
//-----------------------
void
init_star_textures()
{
	image img;
	glGenTextures(1, &texStar);
	STP.create_texture_image(img, 128, 0.35, 4.0);
	set_texture(texStar, img);
}

const star_picture&
get_star_picture()
{
	return  STP;
}

//-----------------------
//  Prepare for Drawing
//-----------------------
void
prepare_draw_stars(const mtk_draw_struct& ds, float Iref)
{
	//  ̖邳̐ݒ(XP[ˑj
	const float scale = ds.scale;
	float amp = 1;
	const float scl0 = 500;
	if (scale > scl0) {
		float a = 4*log10(scale/scl0);
		amp *= (1 + a*a);
	}
	const float lv0 = amp * 100000 / get_L_ref() / Iref;	//***

	const vector3d camera_pos	= ds.camera.get_pos();
	const frustum  frs			= ds.frs;
	const float Rmax = get_Rmax();
	const float Rmax_sqr = Rmax * Rmax;

	for (vector<mtk_star>::iterator it=vStars.begin(); it!=vStars.end(); ++it) {
		it->prepare_draw(ds, frs, camera_pos, Rmax_sqr, lv0, StarImagePowIndex);
	}
}

void
prepare_draw_stars_planetarium(const mtk_draw_struct& ds)
{
	//  ̖邳̐ݒ(XP[ˑj
	const float lv0 = 100000 / get_L_ref();
	const vector3d camera_pos	= ds.camera.get_pos();
	const frustum  frs			= ds.frs;

	GLdouble MM[16];
	glGetDoublev( GL_MODELVIEW_MATRIX,  MM);

	for (vector<mtk_star>::iterator it=vStars.begin(); it!=vStars.end(); ++it) {
		it->prepare_draw_planetarium(ds, frs, camera_pos, MM, lv0, StarImagePowIndex);
	}
}


//--------
//  Draw
//--------
void
draw_a_star(const mtk_draw_struct& ds, const vector3f& xyz, float sz, const RGBf& RGBcr, const int TempIdx, const float af0)
{
	float af = af0;

	//***
	if (sz <= 1.0)  return;


	//----------------------
	//  Textured billboard
	//----------------------
		glEnable(GL_TEXTURE_2D);
		glPushMatrix();
			glTranslatef( xyz.x, xyz.y, xyz.z );
			
			// ʂ̌ݒ肷
			float R;
			R = toward_eye_pos();
		
			float fac = R/screen_z;
			float _sz;
			_sz = sz * fac * screen_w / 180.0;
			_sz *= 0.2;

			glScalef(_sz,_sz,1);
			glColor3f(af,af,af);
			glCallList(dlStar + TempIdx);
		glPopMatrix();
}

//------------------
//  ̃}[N\
//------------------
void
draw_star_mark(const vector3f& xyz, const float sz)
{
	glDisable(GL_TEXTURE_2D);
	glEnable(GL_BLEND);

	glPushMatrix();
		glTranslatef( xyz.x, xyz.y, xyz.z );
		
		// ʂ̌ݒ肷
		float r;
		r = toward_eye_pos();
		float fac = r/screen_z / 2.0*0.6;
		float _sz;
		_sz = sz * fac * screen_w / 180.0;
		_sz += 2 * screen_w / 180.0;

		glScalef(_sz,_sz,1);
		glBegin(GL_LINE_LOOP);
			glVertex3f(-1,-1,0);
			glVertex3f(1,-1,0);
			glVertex3f(1,1,0);
			glVertex3f(-1,1,0);
		glEnd();
	glPopMatrix();
}

//----------------
//  An}[N
//----------------
void
draw_double_star_mark(const mtk_draw_struct& ds, const vector3f& xyz, const mtk_star& st, const float sz, const float alpha)
{
	if (!st.is_double())  return;
	glColor4f(0,1,0,alpha);
	glLineWidth( 0.5 / (ds.rad_per_pixel / 0.001) );
	draw_star_mark(xyz, sz);
}

//------------------------
//  nOf}[N
//------------------------
void
mark_stars_with_planets(const mtk_draw_struct& ds, const vector3f& xyz, const mtk_star& st, const float sz0, const float alpha)
{
	set<int>::const_iterator  it = HippExoplanets.find(st.get_HIP());
	if (it == HippExoplanets.end())  return;

	float sz = sz0;
	if (sz < 1) sz=1;
	glColor4f(1,0.9,0,alpha);
	glLineWidth( 1.5 / (ds.rad_per_pixel / 0.001) );
	draw_star_mark(xyz, sz);
}

int
draw_stars_2_planetarium(const mtk_draw_struct& ds, const int LumRankThr, const GLdouble* MM)
{
	int count = 0;
	for (vector<mtk_star>::const_iterator it=vStars.begin(); it!=vStars.end(); ++it) {
		const mtk_star& st = *it;
		char ty = st.get_draw_type();
		switch (ty) {
			case STAR_DRAW_NONE:	continue;
			case STAR_DRAW_NEAR:	continue;
			case STAR_DRAW_FAR:		break;
			default:				continue;
		}

		const float lv = st.get_lv();
		int  LumRank = STP.get_Lum_rank(lv);

		// Â͕\Ȃ
		const vector3d xyz = st.get_disp_pos();
		if (LumRank > LumRankThr) {
			const float sz = st.get_disp_size();
			int  TempIdx = STP.get_TempIdx(st.get_Tc());
			RGBf RGBcr   = STP.get_correct_RGB(TempIdx, lv);
			glPointSize( sz / (ds.rad_per_pixel / 0.001) );
			draw_a_star(ds, xyz, sz, RGBcr, TempIdx);
			count++;
		}

		if (tyStarMark != STARMARK_NONE) {
			float alp = 1.0;
			const float sz = st.get_disp_size();
			
			switch (tyStarMark) {
				case STARMARK_DOUBLE:		draw_double_star_mark(ds, xyz, st, sz, alp);	break;
				case STARMARK_EXOPLANETS:	mark_stars_with_planets(ds, xyz, st, sz, alp);	break;
				default:																	break;
			}
		}
	}

	return count;
}

int
draw_stars_2_3Dmode(const mtk_draw_struct& ds, const int LumRankThr, const GLdouble* MM, bool bFar)
{
	const float scale = ds.scale;

	int count=0;
	for (vector<mtk_star>::const_iterator it=vStars.begin(); it!=vStars.end(); ++it) {
		const mtk_star& st = *it;

		char ty = st.get_draw_type();
		switch (ty) {
			case STAR_DRAW_NONE:								continue;
			case STAR_DRAW_NEAR:	if (bFar)  { continue; };	break;
			case STAR_DRAW_FAR:		if (!bFar) { continue; };	break;
			default:											continue;
		}

		float lv = st.get_lv();
		int  LumRank = STP.get_Lum_rank(lv);

		// Â͕\Ȃ
		const vector3d xyz = st.get_disp_pos();
		//***
		{
			const float sz = st.get_disp_size();
			int  TempIdx = STP.get_TempIdx(st.get_Tc());
			RGBf RGBcr;
			if (LumRank > LumRankThr) {
				RGBcr = STP.get_correct_RGB(TempIdx, lv);
			} else {
				RGBcr = lv * STP.get_correct_RGB(TempIdx, 1);
			}

			draw_a_star(ds, xyz, sz, RGBcr, TempIdx);
			count++;
		}

		if (tyStarMark != STARMARK_NONE) {
			float alp = 1.0;
			if (scale > 2000) {
				alp *= 1 - (scale-2000)/(4000-2000);
				if (alp < 0)  continue;
			}

			const float sz = st.get_disp_size();
			if (sz < 0.01) continue;

			switch (tyStarMark) {
				case STARMARK_DOUBLE:		draw_double_star_mark(ds, xyz, st, sz, alp);	break;
				case STARMARK_EXOPLANETS:	mark_stars_with_planets(ds, xyz, st, sz, alp);	break;
				default:																	break;
			}
		}
	}

	return count;
}



int
draw_stars_2(const mtk_draw_struct& ds, bool _bDrawLowRes, bool bFar)
{
	//-- For culling
	GLdouble MM[16];
	glGetDoublev( GL_MODELVIEW_MATRIX,  MM);

	glEnable(GL_BLEND);
	glDepthMask(GL_FALSE);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE);
	glBindTexture(GL_TEXTURE_2D, texStar);
	glPointSize(1.0);

	int count = 0;
	if (tyMode==MODE_PLANETARIUM) {
		count = draw_stars_2_planetarium(ds, 7, MM);
	} else {
		glPushMatrix();
			const int LumRankThr = 2;
			count = draw_stars_2_3Dmode(ds, LumRankThr, MM, bFar);
		glPopMatrix();
	}

	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glDisable(GL_TEXTURE_2D);
	glDepthMask(GL_TRUE);
	return count;
}

//----------------
//  ̖O
//----------------
void
draw_star_name_3D(const mtk_draw_struct& ds)
{
	if (!(swStar & (STAR_NAME | STAR_BAYER | STAR_FRAMSTEED | STAR_HIP)))  return;

	RGBAf rgba;
	rgba.rgb = get_color(MTK_COLOR_NAME_OBJECT);
	const vector3d camera_pos	= ds.camera.get_pos();
	const double scl			= ds.scale;

	glDisable(GL_DEPTH_TEST);
	for (vector<mtk_star>::const_iterator it=vStars.begin(); it!=vStars.end(); ++it) {
		const mtk_star& st = *it;
		const char* name_L = st.get_name_L();
		const char* name_S = st.get_name_S();
		const bool bNameLarge = (name_L[0] != '\0');
		const bool bNameSmall = (name_S[0] != '\0');
		if (!bNameLarge && !bNameSmall)		continue;	// \閼Oꍇ
		vector3d xyz = st.get_pos() - camera_pos;
		float r1 = xyz.norm() / scl;
		float r2 = norm(st.get_pos()) / scl;

		float af;
		af = calc_alpha(0.03, 1.2, r1, 1.0);	
		if (af > 0.0f && r2 < 0.06) {
			af *= calc_alpha(0.04, 0.7, r2, 1.0)/0.9;
		}
		if (af <= 0.0f)	continue;

		glPushMatrix();
			glTranslatef(xyz.x, xyz.y, xyz.z);
			rgba.a = af;
			glColor4fv(rgba.get_pointer());

			const float sz = 0.2 * st.get_disp_size();	//***
			prepare_3Dtext_1(sz*1.4, 45, ObjectNameSize*ds.ltf, 1.0f, true);

			if (bNameLarge) {
				draw_text(name_L);
			}

			if (bNameSmall) {
                const float f = 4.0/5.0;
				glScalef(f,f,f);

				if (bNameLarge)		draw_textf("(%s)", name_S);
				else				draw_text(name_S);
			}
		glPopMatrix();
	}
	glEnable(GL_DEPTH_TEST);
}

//  ̖ÕeLXg
void
make_star_name_text_2(char _swStar, char _swCnst)
{
	const char lang = get_language();
	for (vector<mtk_star>::iterator it=vStars.begin(); it!=vStars.end(); ++it) {
		it->make_name(_swStar, _swCnst, lang);
	}
}


//--------------
//  Star Names
//--------------
bool
read_star_names(const directory& dir)
{
	const int BUF_SIZE = 200;
	FILE *fp;

	//-- open catalogue file
	fp  = dir.fopen("star_names_HIP.dat", "rt");
	if (fp==NULL)  return false;

	StarNames.clear();
	while (true) {
		star_name sn;
		char buf[BUF_SIZE];
		char buf2[BUF_SIZE];
		
		//-- read one line
		if ( !read_one_line(fp, buf, BUF_SIZE) )  break;
		//-- HIP number
		if ( !extract_string(buf, 0, 5, buf2) ) continue;
		sscanf(buf2, "%ld", &sn.HIP);
		//-- Flag
		sn.flg = buf[6];
		//-- Star name (English)
		if ( !extract_string(buf, 7, 26, sn.name_E) ) continue;
		//-- Star name (Japanese)
		if ( !extract_string(buf, 28, 62, sn.name_J ) ) continue;
		//-- Add to the vector
		StarNames.push_back(sn);
	}
	return true;
}

void
attach_star_names()
{
	for (int i=0; i<StarNames.size(); i++) {
		map<long, long>::iterator it = HIP_table.find( StarNames[i].HIP );
		if (it==HIP_table.end())  continue;	// no match
		mtk_star& st = vStars[it->second];
		st.set_common_name_index(i);
	}
}

void
load_star_common_names(const directory& dir)
{
	read_star_names(dir);
	attach_star_names();
}



