/**************************************************************************************************

Copyright (c) 2007   Tsunehiko Kato  and  4D2U Project, National Astronomical Observatory of Japan

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEFAvj̕擾
邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ܂Bɂ́A\tgEFA̕
gpAʁAύXAAfځAЕzATuCZXA/܂͔̔錠Aу\tgEFA
񋟂鑊ɓƂ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕɋLڂ̂Ƃ
B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂Ȃ񋟂܂B
łۏ؂Ƃ́AiA̖ړIւ̓KAьNQɂĂ̕ۏ؂܂݂܂AɌ
̂ł͂܂B ҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\t
gEFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
***************************************************************************************************/
#ifndef __MTK_TARGET_H__
#define __MTK_TARGET_H__
#include "../common/math/vector3.h"


//-------------------
//  ^[Qbg̃NX
//-------------------
enum {
	TGTCLS_NONE,
	TGTCLS_SUN,
	TGTCLS_PLANET,
	TGTCLS_SATELLITE,
	TGTCLS_SMALL_OBJECT,
	TGTCLS_COMET,
	TGTCLS_PROBE,
	TGTCLS_STAR,
	TGTCLS_FIXED
};

struct mtk_target {
	char		cls;			// NX
	int			id1, id2, id3;	//
	double		ini_scale;		// ^[Qbg؂ւ̏XP[
};



//------------------
//  ^[Qbg̎
//------------------
enum {
	TGTNO_NONE,
	TGTNO_SUN,
	TGTNO_MERCURY,
	TGTNO_VENUS,
	TGTNO_EARTH,
	TGTNO_MARS,
	TGTNO_JUPITER,
	TGTNO_SATURN,
	TGTNO_URANUS,
	TGTNO_NEPTUNE,
	TGTNO_PLUTO,
	TGTNO_ERIS,
	TGTNO_SEDNA,
	TGTNO_MOON,
	TGTNO_IO,
	TGTNO_PIONEER10,
	TGTNO_PIONEER11,
	TGTNO_VOYAGER1,
	TGTNO_VOYAGER2,
	TGTNO_CASSINI,
	TGTNO_ALP_CEN,
	TGTNO_SIRIUS,
	TGTNO_SUBARU,
	TGTNO_CASTOR,
	TGTNO_M13,
	TGTNO_OUR_GALAXY_CENTER,
	TGTNO_OUR_GALAXY,
	TGTNO_M31,
	TGTNO_VIRGO_CLUSTER,
	TGTNO_LSS
};
extern	char  tyTarget;		// ^[Qbg̎


//-------------
//  Functions
//-------------
double	get_target_ini_scale(int tgt_no);
const mtk_target&	get_current_target();
const mtk_target&	get_target(int idx);
int					get_goto_command_target_no(int idx);
const vector3d&		get_target_center_pos();
const vector3d&		get_current_target_pos();
void				set_target_pos(const vector3d& pos);
float				get_target_radius();
void				adjust_target_position();
void				update_target_pos();


#endif
