/**************************************************************************************************

Copyright (c) 2007   Tsunehiko Kato  and  4D2U Project, National Astronomical Observatory of Japan

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEFAvj̕擾
邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ܂Bɂ́A\tgEFA̕
gpAʁAύXAAfځAЕzATuCZXA/܂͔̔錠Aу\tgEFA
񋟂鑊ɓƂ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕɋLڂ̂Ƃ
B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂Ȃ񋟂܂B
łۏ؂Ƃ́AiA̖ړIւ̓KAьNQɂĂ̕ۏ؂܂݂܂AɌ
̂ł͂܂B ҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\t
gEFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
***************************************************************************************************/
#ifndef __MTK_TRACKBALL_H__
#define __MTK_TRACKBALL_H__
#include  "../common/math/vector3.h"
#include  "../common/math/quaternion.h"



class  mtk_trackball
{
	vector3f	Omg;
	float		rho;	// density
	float		mu;		// froction
	quaternionf	dori;
public:
	mtk_trackball() : Omg(0,0,0), mu(0), rho(1)  {};

	void	reset_angular_velocity()	{ Omg.set(0,0,0); }
	void	set_angular_velocity(const vector3f& _Omg)	{ Omg = _Omg; }
	void	set_density(float _rho)		{ rho = _rho; }
	void	set_friction(float _mu)		{ mu  = _mu; }

	float		proceed_time(float dt, float Fx, float Fy, float Fs);
	quaternionf	get_dori() const		{ return dori; }
};



class  mtk_lever
{
	float  v;
	float  mass;
	float  mu;
	float  dx;
public:
	mtk_lever() : v(0), mu(0), mass(1)  {};

	void	set_velocity(float _v)		{ v  = _v;  }
	void	set_mass(float _mass)		{ mass = _mass; }
	void	set_friction(float _mu)		{ mu = _mu; }
	float	get_friction() const		{ return mu; }

	float	proceed_time(float dt, float F);
	float	get_dx() const	{ return dx; }
};



#endif
